SystemOrganization addCategory: #'Small Lint Failure-Tests'!
SystemOrganization addCategory: #'Small Lint Failure-Model'!
SystemOrganization addCategory: #'Small Lint Failure-UI'!

!ProtocolEnvironment methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 12:34'!
failuresFor: aLintRule 

	self error: 'The implementation does not support failures for this environment'! !

!CategoryEnvironment methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 12:34'!
failuresFor: aLintRule 

	self error: 'The implementation does not support failures for this environment'! !

!AndEnvironment methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 12:34'!
failuresFor: aLintRule 

	self error: 'The implementation does not support failures for this environment'! !

Object subclass: #ExpectedSmallLintFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

ExpectedSmallLintFailure subclass: #ExpectedSmallLintClassFailure
	instanceVariableNames: 'failedClass reasonDescription definedBy ruleIdentifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!ExpectedSmallLintClassFailure class methodsFor: 'instance creation' stamp: 'HAW 11/1/2005 10:24'!
forRule: aRuleName failedClass: aClass reasonDescription: aString definedBy: aUserName 
	^self new 
		initializeForRule: aRuleName
		failedClass: aClass
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintClassFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:52'!
definedBy

	^definedBy! !

!ExpectedSmallLintClassFailure methodsFor: 'accessing' stamp: 'HAW 12/17/2005 12:45'!
definedEnvironment
	
	^ClassEnvironment onEnvironment: BrowserEnvironment new classes: (Array with: failedClass).
! !

!ExpectedSmallLintClassFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:25'!
failedClass

	^failedClass! !

!ExpectedSmallLintClassFailure methodsFor: 'initialization' stamp: 'HAW 11/1/2005 10:25'!
initializeForRule: aRuleName failedClass: aClass reasonDescription: aString definedBy: aUserName 
	ruleIdentifier := aRuleName.
	failedClass := aClass.
	reasonDescription := aString.
	definedBy := aUserName! !

!ExpectedSmallLintClassFailure methodsFor: 'testing' stamp: 'HAW 11/1/2005 10:26'!
isForSameFailure: aSmallLintFailure 

	^failedClass = aSmallLintFailure failedClass! !

!ExpectedSmallLintClassFailure methodsFor: 'printing' stamp: 'HAW 11/1/2005 10:26'!
printOn: aStream

	aStream
		nextPutAll: failedClass name;
		nextPutAll: ' - Failure ';
		nextPutAll: self ruleName;
		nextPutAll: ' - Reason: ';
		nextPutAll: reasonDescription;
		nextPutAll: ' - Created by: ';
		nextPutAll: definedBy.
! !

!ExpectedSmallLintClassFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:52'!
reasonDescription

	^reasonDescription! !

!ExpectedSmallLintClassFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:25'!
ruleIdentifier

	^ruleIdentifier! !

!ExpectedSmallLintClassFailure methodsFor: 'testing' stamp: 'HAW 12/17/2005 12:46'!
shouldBeExpectedIn: anEnvironment

	^anEnvironment includesClass: failedClass! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - class fails' stamp: 'HAW 12/18/2005 12:42'!
abstractClassFailedClass: aClass reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintClassFailure 
		forRule: #abstractClass
		failedClass: aClass
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - class fails' stamp: 'HAW 12/18/2005 12:42'!
addRemoveDependentsFailedClass: aClass reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintClassFailure 
		forRule: #addRemoveDependents
		failedClass: aClass
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
asOrderedCollectionNotNeededFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #asOrderedCollectionNotNeeded
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
assignmentInBlockFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #assignmentInBlock
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
assignmentInIfTrueFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #assignmentInIfTrue
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
atIfAbsentFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #atIfAbsent
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
badMessageFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #badMessage
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
booleanPrecedenceFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #booleanPrecedence
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - class fails' stamp: 'HAW 12/18/2005 12:42'!
classInstVarNotInitializedFailedClass: aClass reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintClassFailure 
		forRule: #classInstVarNotInitialized
		failedClass: aClass
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
classNameInSelectorFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #classNameInSelector
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - class fails' stamp: 'HAW 12/18/2005 12:42'!
classNotReferencedFailedClass: aClass reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintClassFailure 
		forRule: #classNotReferenced
		failedClass: aClass
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
collectionMessagesToExternalObjectFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #collectionMessagesToExternalObject
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
collectionProtocolFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #collectionProtocol
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
collectSelectNotUsedFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #collectSelectNotUsed
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
consistencyCheckFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #consistencyCheck
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
containsFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #contains
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - class fails' stamp: 'HAW 12/18/2005 12:42'!
definesEqualNotHashFailedClass: aClass reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintClassFailure 
		forRule: #definesEqualNotHash
		failedClass: aClass
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
detectContainsFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #detectContains
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
endTrueFalseFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #endTrueFalse
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
equalNotUsedFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	"It should be MCPExpectedSmallLintMethodTextFail but the searchstrings does not contains anything"

	^ExpectedSmallLintMethodFailure 
		forRule: #equalNotUsed
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
equalsTrueFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #equalsTrue
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
equivalentSuperclassMethodsFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #equivalentSuperclassMethods
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'small lint' stamp: 'HAW 12/19/2005 10:41'!
expectedSmallLintFailures

	^Array with: (
		self
			abstractClassFailedClass: self
			reasonDescription: 'It is use to create the concrete subclasses'
			definedBy: 'HAW')
! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
extraBlockFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #extraBlock
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
fileBlocksFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	"It should be MCPExpectedSmallLintMethodTextFail but the searchstrings does not contains anything"

	^ExpectedSmallLintMethodFailure 
		forRule: #fileBlocks
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
fullBlocksFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #fullBlocks
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
guardingClauseFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #guardingClause
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
ifTrueBlocksFailedClass: aClass ifTrueBlocks: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #ifTrueBlocks
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
ifTrueReturnsFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #ifTrueReturns
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
implementedNotSentFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #implementedNotSent
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - variable fails' stamp: 'HAW 12/18/2005 14:32'!
instVarInSubclassesFailedClass: aClass failedVariable: aVariableName reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintVariableFailure 
		forRule: #instVarInSubclasses
		failedClass: aClass
		failedVariable: aVariableName
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
justSendsSuperFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #justSendsSuper
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
literalArrayCharactersFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #literalArrayCharacters
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
literalArrayContainsCommaFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #literalArrayContainsComma
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
literalArrayContainsSuspiciousTrueFalseOrNilFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #literalArrayContainsSuspiciousTrueFalseOrNil
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
longMethodsFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #longMethods
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
minMaxFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #minMax
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - class fails' stamp: 'HAW 12/18/2005 12:42'!
missingSubclassResponsibilityFailedClass: aClass reasonDescription: aString definedBy: aUserName 
	"No puede implementarse como un MCPExpectedSmallLintMethodFailure ya que #shouldBeExpectedIn:
	depende de que el Environment INCLUYA al metodo especificado en el failedMethod: del expected failure...
	y como justamente este failure hace referencia a un metodo que NO existe y deberia existir hay que
	utilizar un class failure.  No se si seria mejor implementar otro tipo de failure para este caso en
	lugar de utilizar un class failure."

	^ExpectedSmallLintClassFailure 
		forRule: #missingSubclassResponsibility
		failedClass: aClass
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
missingYourselfFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	"It should be MCPExpectedSmallLintMethodTextFail but the searchstrings does not contains anything"

	^ExpectedSmallLintMethodFailure 
		forRule: #missingYourself
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
modifiesCollectionFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	"It should be MCPExpectedSmallLintMethodTextFail but the searchstrings does not contains anything"

	^ExpectedSmallLintMethodFailure 
		forRule: #modifiesCollection
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - variable fails' stamp: 'HAW 12/18/2005 14:32'!
onlyReadOrWrittenFailedClass: aClass failedVariable: aVariableName reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintVariableFailure 
		forRule: #onlyReadOrWritten
		failedClass: aClass
		failedVariable: aVariableName
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - class fails' stamp: 'HAW 12/18/2005 12:42'!
overridesSpecialMessageFailedClass: aClass reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintClassFailure 
		forRule: #overridesSpecialMessage
		failedClass: aClass
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
overridesSuperFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #overridesSuper
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
precedenceFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #precedence
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
refersToClassFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #refersToClass
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
returnInEnsureFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	"It should be MCPExpectedSmallLintMethodTextFail but the searchstrings does not contains anything"

	^ExpectedSmallLintMethodFailure 
		forRule: #returnInEnsure
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
returnsBooleanAndOtherFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #returnsBooleanAndOther
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
returnsIfTrueFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	"It should be MCPExpectedSmallLintMethodTextFail but the searchstrings does not contains anything"

	^ExpectedSmallLintMethodFailure 
		forRule: #returnsIfTrue
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
searchingLiteralFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #searchingLiteral
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method text fails' stamp: 'HAW 12/18/2005 14:31'!
sendsDifferentSuper: superSentSelector failedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodTextFailure 
		forRule: #sendsDifferentSuper
		failedClass: aClass
		failedMethod: aSelector
		invalidText: superSentSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
sendsUnknownMessageToGlobalFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #sendsUnknownMessageToGlobal
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method text fails' stamp: 'HAW 12/18/2005 14:31'!
sentNotImplemented: aSymbol failedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodTextFailure 
		forRule: #sentNotImplemented
		failedClass: aClass
		failedMethod: aSelector
		invalidText: aSymbol
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
sizeCheckFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #sizeCheck
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
stringConcatenationFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #stringConcatenation
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
subclassResponsibilityNotDefinedFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #subclassResponsibilityNotDefined
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
superSendsFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #superSends
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method text fails' stamp: 'HAW 12/18/2005 14:31'!
tempsReadBeforeWritten: aVariableName failedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodTextFailure 
		forRule: #tempsReadBeforeWritten
		failedClass: aClass
		failedMethod: aSelector
		invalidText: aVariableName
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method text fails' stamp: 'HAW 12/18/2005 14:31'!
tempVarOverridesInstVar: variableName failedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodTextFailure 
		forRule: #tempVarOverridesInstVar
		failedClass: aClass
		failedMethod: aSelector
		invalidText: variableName
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
threeElementPointFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	"It should be MCPExpectedSmallLintMethodTextFail but the searchstrings does not contains anything"

	^ExpectedSmallLintMethodFailure 
		forRule: #threeElementPoint
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
toDoCollectFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #toDoCollect
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
toDoFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #toDo
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
toDoWithIncrementFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #toDoWithIncrement
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method text fails' stamp: 'HAW 12/18/2005 14:31'!
undeclaredReference: aSymbol failedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodTextFailure 
		forRule: #undeclaredReference
		failedClass: aClass
		failedMethod: aSelector
		invalidText: aSymbol
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
unnecessaryAssignmentFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #unnecessaryAssignment
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
unoptimizedAndOrFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #unoptimizedAndOr
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
unoptimizedToDoFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #unoptimizedToDo
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - variable fails' stamp: 'HAW 12/18/2005 14:32'!
unreferencedVariablesFailedClass: aClass failedVariable: aVariableName reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintVariableFailure 
		forRule: #unreferencedVariables
		failedClass: aClass
		failedVariable: aVariableName
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
usesAddFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	"It should be MCPExpectedSmallLintMethodTextFail but the searchstrings does not contains anything"

	^ExpectedSmallLintMethodFailure 
		forRule: #usesAdd
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
usesTrueFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #usesTrue
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
utilityMethodsFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #utilityMethods
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - variable fails' stamp: 'HAW 12/18/2005 14:32'!
variableAssignedLiteralFailedClass: aClass failedVariable: aVariableName reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintVariableFailure 
		forRule: #variableAssignedLiteral
		failedClass: aClass
		failedVariable: aVariableName
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method text fails' stamp: 'HAW 12/18/2005 14:31'!
variableNotDefined: aVariableName failedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	"I assume that the result will be a method text environment. I wrote this while the small lint is not working, so this may change
	when the rule starts to work - Hernan"

	^ExpectedSmallLintMethodTextFailure 
		forRule: #variableNotDefined
		failedClass: aClass
		failedMethod: aSelector
		invalidText: aVariableName
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method text fails' stamp: 'HAW 12/18/2005 14:31'!
variableReferencedOnce: aVariableName failedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodTextFailure 
		forRule: #variableReferencedOnce
		failedClass: aClass
		failedMethod: aSelector
		invalidText: aVariableName
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
whileTrueFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #whileTrue
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure class methodsFor: 'instance creation - method fails' stamp: 'HAW 12/18/2005 14:31'!
yourselfNotUsedFailedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^ExpectedSmallLintMethodFailure 
		forRule: #yourselfNotUsed
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 10:22'!
classToSearchSendersOn 

	^self failedClass isMeta
		ifTrue: [ self failedClass soleInstance ]
		ifFalse: [ self failedClass ].! !

!ExpectedSmallLintFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 10:19'!
codeToSearchExpectedFailure 

	| stream |
		
	stream := WriteStream on: String new.
	stream 
		nextPutAll: self class name;
		nextPutAll: ' browseExpectedFailuresFor: ''';
		nextPutAll: self sendersPattern;
		nextPutAll: ''' in: ';		
		nextPutAll: self classToSearchSendersOn name.
		
	^stream contents! !

!ExpectedSmallLintFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:52'!
definedBy
		
		self subclassResponsibility! !

!ExpectedSmallLintFailure methodsFor: 'accessing' stamp: 'HAW 12/17/2005 12:45'!
definedEnvironment

	self subclassResponsibility! !

!ExpectedSmallLintFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:17'!
failedClass

	self subclassResponsibility! !

!ExpectedSmallLintFailure methodsFor: 'testing' stamp: 'HAW 11/1/2005 10:19'!
isForSameFailure: aSmallLintFailure 

	self subclassResponsibility
! !

!ExpectedSmallLintFailure methodsFor: 'testing' stamp: 'HAW 11/1/2005 10:20'!
isForSameRule: aSmallLintFailure

	^self ruleName=aSmallLintFailure ruleName ! !

!ExpectedSmallLintFailure methodsFor: 'testing' stamp: 'HAW 11/1/2005 10:19'!
isFor: aSmallLintFailure
	
	^(self isForSameRule: aSmallLintFailure) and: [ self isForSameFailure: aSmallLintFailure ]		
! !

!ExpectedSmallLintFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:52'!
reasonDescription
	
	self subclassResponsibility! !

!ExpectedSmallLintFailure methodsFor: 'accessing' stamp: 'HAW 12/18/2005 14:33'!
rule
	^SmallLintRuleInformation ruleFor: self ruleIdentifier! !

!ExpectedSmallLintFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:18'!
ruleIdentifier

	self subclassResponsibility! !

!ExpectedSmallLintFailure methodsFor: 'accessing' stamp: 'HAW 12/18/2005 14:33'!
ruleName
	^SmallLintRuleInformation ruleNameFor: self ruleIdentifier! !

!ExpectedSmallLintFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 10:19'!
sendersPattern

	^self ruleIdentifier asString,'FailedClass:*'! !

!ExpectedSmallLintFailure methodsFor: 'testing' stamp: 'HAW 12/17/2005 12:45'!
shouldBeExpectedIn: anEnvironment

	self subclassResponsibility! !

ExpectedSmallLintFailure subclass: #ExpectedSmallLintMethodFailure
	instanceVariableNames: 'selector reasonDescription definedBy failedClass ruleIdentifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!ExpectedSmallLintMethodFailure class methodsFor: 'instance creation' stamp: 'HAW 11/1/2005 10:27'!
forRule: aRuleName failedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName 
	^self new 
		initializeForRule: aRuleName
		failedClass: aClass
		failedMethod: aSelector
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:56'!
definedBy

	^definedBy! !

!ExpectedSmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 12/17/2005 12:46'!
definedEnvironment
	
	^SelectorEnvironment onMethods: (Array with: selector) forClass: failedClass in: BrowserEnvironment new	! !

!ExpectedSmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:28'!
failedClass

	^failedClass! !

!ExpectedSmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:28'!
failedMethod

	^selector! !

!ExpectedSmallLintMethodFailure methodsFor: 'initialization' stamp: 'HAW 11/1/2005 10:28'!
initializeForRule: aRuleName failedClass: aClass failedMethod: aSelector reasonDescription: aString definedBy: aUserName
		
	ruleIdentifier := aRuleName.
	failedClass := aClass.
	selector := aSelector.
	reasonDescription := aString.
	definedBy := aUserName! !

!ExpectedSmallLintMethodFailure methodsFor: 'testing' stamp: 'HAW 11/1/2005 10:29'!
isForSameFailure: aSmallLintFailure
 
	^failedClass = aSmallLintFailure failedClass and: [selector = aSmallLintFailure failedMethod]! !

!ExpectedSmallLintMethodFailure methodsFor: 'printing' stamp: 'HAW 11/1/2005 10:29'!
printOn: aStream

	aStream
		nextPutAll: failedClass name;
		nextPutAll: '>>';
		nextPutAll: selector;
		nextPutAll: ' - Failure ';
		nextPutAll: self ruleName;
		nextPutAll: ' - Reason: ';
		nextPutAll: reasonDescription;
		nextPutAll: ' - Created by: ';
		nextPutAll: definedBy.! !

!ExpectedSmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:56'!
reasonDescription

	^reasonDescription! !

!ExpectedSmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:28'!
ruleIdentifier

	^ruleIdentifier! !

!ExpectedSmallLintMethodFailure methodsFor: 'testing' stamp: 'HAW 12/17/2005 12:46'!
shouldBeExpectedIn: anEnvironment

	^anEnvironment includesSelector: selector in: failedClass! !

ExpectedSmallLintFailure subclass: #ExpectedSmallLintMethodTextFailure
	instanceVariableNames: 'selector reasonDescription definedBy failedClass ruleIdentifier text invalidText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!ExpectedSmallLintMethodTextFailure class methodsFor: 'instance creation' stamp: 'HAW 11/1/2005 10:30'!
forRule: aRuleName failedClass: aClass failedMethod: aSelector invalidText: anInvalidText reasonDescription: aString definedBy: aUserName 
	^self new 
		initializeForRule: aRuleName
		failedClass: aClass
		failedMethod: aSelector
		invalidText: anInvalidText
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:56'!
definedBy
	
	^definedBy! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'accessing' stamp: 'HAW 12/17/2005 12:47'!
definedEnvironment
	
	^SelectorEnvironment onMethods: (Array with: selector) forClass: failedClass in: BrowserEnvironment new! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:31'!
failedClass

	^failedClass! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:31'!
failedMethod

	^selector! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'initialization' stamp: 'HAW 11/1/2005 10:32'!
initializeForRule: aRuleName failedClass: aClass failedMethod: aSelector invalidText: anInvalidText reasonDescription: aString definedBy: aUserName

	ruleIdentifier := aRuleName.
	failedClass := aClass.
	selector := aSelector.
	invalidText := anInvalidText.
	reasonDescription := aString.
	definedBy := aUserName! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:56'!
invalidText

	^invalidText! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'testing' stamp: 'HAW 11/1/2005 10:33'!
isForSameFailure: aSmallLintFailure 

	^failedClass = aSmallLintFailure failedClass 
		and: [selector = aSmallLintFailure failedMethod
		and: [aSmallLintFailure rule result searchStrings includes: invalidText]]! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'printing' stamp: 'HAW 11/1/2005 10:32'!
printOn: aStream

	aStream
		nextPutAll: failedClass name;
		nextPutAll: '>>';
		nextPutAll: selector;
		nextPutAll: ' - Invalid Text: ';
		nextPutAll: invalidText;
		nextPutAll: ' - Failure: ';
		nextPutAll: self ruleName;
		nextPutAll: ' - Reason: ';
		nextPutAll: reasonDescription;
		nextPutAll: ' - Created by: ';
		nextPutAll: definedBy.! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:57'!
reasonDescription

	^reasonDescription! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:31'!
ruleIdentifier

	^ruleIdentifier! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 10:31'!
sendersPattern

	^self ruleIdentifier asString,':*'! !

!ExpectedSmallLintMethodTextFailure methodsFor: 'testing' stamp: 'HAW 12/17/2005 12:47'!
shouldBeExpectedIn: anEnvironment

	^anEnvironment includesSelector: selector in: failedClass! !

ExpectedSmallLintFailure subclass: #ExpectedSmallLintVariableFailure
	instanceVariableNames: 'variableName reasonDescription definedBy failedClass ruleIdentifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!ExpectedSmallLintVariableFailure class methodsFor: 'instance creation' stamp: 'HAW 11/1/2005 10:44'!
forRule: aRuleName failedClass: aClass failedVariable: aVariableName reasonDescription: aString definedBy: aUserName 
	^self new 
		initializeForRule: aRuleName
		failedClass: aClass
		failedVariable: aVariableName
		reasonDescription: aString
		definedBy: aUserName! !

!ExpectedSmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:59'!
definedBy

	^definedBy! !

!ExpectedSmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 12/18/2005 14:44'!
definedEnvironment
	
	^VariableEnvironment smallLintFailureReferencesToInstanceVariable: variableName in: failedClass! !

!ExpectedSmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:45'!
failedClass

	^failedClass! !

!ExpectedSmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:59'!
failedVariable

	^variableName! !

!ExpectedSmallLintVariableFailure methodsFor: 'initialization' stamp: 'HAW 11/1/2005 10:45'!
initializeForRule: aRuleName failedClass: aClass failedVariable: aVariableName reasonDescription: aString definedBy: aUserName
		
	ruleIdentifier := aRuleName.
	failedClass := aClass.
	variableName := aVariableName.
	reasonDescription := aString.
	definedBy := aUserName! !

!ExpectedSmallLintVariableFailure methodsFor: 'testing' stamp: 'HAW 11/1/2005 10:46'!
isForSameFailure: aSmallLintFailure 

	^failedClass = aSmallLintFailure failedClass and: [variableName = aSmallLintFailure failedVariable]! !

!ExpectedSmallLintVariableFailure methodsFor: 'printing' stamp: 'HAW 11/1/2005 10:46'!
printOn: aStream

	aStream
		nextPutAll: failedClass name;
		nextPutAll: ' - Variable: ';
		nextPutAll: variableName;
		nextPutAll: ' - Failure: ';
		nextPutAll: self ruleName;
		nextPutAll: ' - Reason: ';
		nextPutAll: reasonDescription;
		nextPutAll: ' - Created by: ';
		nextPutAll: definedBy.! !

!ExpectedSmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:59'!
reasonDescription

	^reasonDescription! !

!ExpectedSmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:45'!
ruleIdentifier

	^ruleIdentifier! !

!ExpectedSmallLintVariableFailure methodsFor: 'testing' stamp: 'HAW 12/17/2005 12:48'!
shouldBeExpectedIn: anEnvironment

	^anEnvironment includesClass: failedClass! !

!ExpectedSmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:59'!
variableName

	^variableName! !

Object subclass: #ExpectedSmallLintFailuresCollector
	instanceVariableNames: 'environment classesToIgnore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!ExpectedSmallLintFailuresCollector class methodsFor: 'instance creation' stamp: 'HAW 12/17/2005 14:53'!
on: anEnvironment 

	^self new initializeOn: anEnvironment ! !

!ExpectedSmallLintFailuresCollector methodsFor: 'utility' stamp: 'HAW 12/17/2005 14:54'!
expectedFailuresFor: aClass 

	^aClass isMeta
		ifTrue: [ #() ]
		ifFalse: [ (self specificFailuresFor: aClass),(self inheritedFailuresFor: aClass) ]
! !

!ExpectedSmallLintFailuresCollector methodsFor: 'utility' stamp: 'HAW 12/17/2005 12:50'!
filteredExpectedFailuresFor: aClass 

	^(self expectedFailuresFor: aClass) select: [ :anExpectedFailure | anExpectedFailure shouldBeExpectedIn: environment ]
! !

!ExpectedSmallLintFailuresCollector methodsFor: 'utility' stamp: 'HAW 12/17/2005 12:50'!
inheritedFailuresFor: aClass 
	
	^aClass inheritedExpectedSmallLintFailures
	
! !

!ExpectedSmallLintFailuresCollector methodsFor: 'initialization' stamp: 'HAW 12/17/2005 12:50'!
initializeOn: anEnvironment 

	environment := anEnvironment! !

!ExpectedSmallLintFailuresCollector methodsFor: 'utility' stamp: 'HAW 12/17/2005 12:55'!
specificFailuresFor: aClass 

	^aClass expectedSmallLintFailures
	! !

!ExpectedSmallLintFailuresCollector methodsFor: 'evaluationg' stamp: 'HAW 12/17/2005 12:49'!
value

	| expectedFailures |
	
	expectedFailures := OrderedCollection new.
	environment classesDo: [:aClass | expectedFailures addAll: (self filteredExpectedFailuresFor: aClass) ].
	
	^expectedFailures
! !

Object subclass: #LintRuleWithIdentifier
	instanceVariableNames: 'rule identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!LintRuleWithIdentifier class methodsFor: 'instance creation' stamp: 'HAW 12/17/2005 12:57'!
rule: aLintRule identifier: aSelector
	
	^self new initializeRule: aLintRule identifier: aSelector! !

!LintRuleWithIdentifier methodsFor: 'proxy implementation' stamp: 'HAW 12/17/2005 12:57'!
doesNotUnderstand: aMessage
	
	^aMessage sendTo: rule! !

!LintRuleWithIdentifier methodsFor: 'accessing' stamp: 'HAW 12/17/2005 12:56'!
identifier
	
	^identifier! !

!LintRuleWithIdentifier methodsFor: 'initialization' stamp: 'HAW 12/17/2005 12:57'!
initializeRule: aLintRule identifier: aSelector
	
	rule := aLintRule.
	identifier := aSelector! !

Object subclass: #MockLintRule
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!MockLintRule class methodsFor: 'instance creation' stamp: 'HAW 11/1/2005 16:53'!
named: aSymbol 
	
	^self new initializeNamed: aSymbol ! !

!MockLintRule methodsFor: 'initialization' stamp: 'HAW 11/1/2005 16:53'!
initializeNamed: aSymbol 
	
	name := aSymbol! !

!MockLintRule methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:53'!
name

	^name! !

Object subclass: #SmallLintFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

SmallLintFailure subclass: #SmallLintClassFailure
	instanceVariableNames: 'lintRule failedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!SmallLintClassFailure class methodsFor: 'instance creation' stamp: 'HAW 11/1/2005 10:49'!
for: aLintRule in: aClass 
	
	^self new initializeFor: aLintRule in: aClass! !

!SmallLintClassFailure methodsFor: 'accessing' stamp: 'HAW 12/18/2005 23:47'!
definedEnvironment
	
	^ClassEnvironment onEnvironment: BrowserEnvironment new classes: (Array with: failedClass).
! !

!SmallLintClassFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 10:59'!
expectedFailureInstanceCreationCodeTemplate

	| stream |
	
	stream := WriteStream on: String new.
	stream
		nextPutAll: self expectedSmallLintFailureClass name;
		space;
		nextPutAll: self ruleIdentifier asString;
		nextPutAll: 'FailedClass: self class reasonDescription: <aString> definedBy: ''';
		nextPutAll: self userInitials;
		nextPutAll: ''''.

	^stream contents.
	! !

!SmallLintClassFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:49'!
failedClass

	^failedClass! !

!SmallLintClassFailure methodsFor: 'initialization' stamp: 'HAW 11/1/2005 10:55'!
initializeFor: aLintRule in: aClass 
	lintRule := aLintRule.
	failedClass := aClass! !

!SmallLintClassFailure methodsFor: 'printing' stamp: 'HAW 11/1/2005 10:56'!
printOn: aStream

	aStream
		nextPutAll: failedClass name;
		nextPutAll: ' - Failure: ';
		nextPutAll: lintRule name.! !

!SmallLintClassFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:49'!
rule

	^lintRule! !

!SmallLintFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 10:48'!
expectedFailureInstanceCreationCodeTemplate

	self subclassResponsibility
	! !

!SmallLintFailure methodsFor: 'accessing' stamp: 'HAW 12/18/2005 14:31'!
expectedSmallLintFailureClass
	^ExpectedSmallLintFailure! !

!SmallLintFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:47'!
failedClass

	self subclassResponsibility! !

!SmallLintFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:48'!
rule

	self subclassResponsibility! !

!SmallLintFailure methodsFor: 'accessing' stamp: 'HAW 12/18/2005 14:33'!
ruleIdentifier
	^SmallLintRuleInformation ruleIdentifierFor: self rule! !

!SmallLintFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:48'!
ruleName

	^self rule name! !

!SmallLintFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 17:04'!
userInitials

	^Utilities authorInitials! !

SmallLintFailure subclass: #SmallLintMethodFailure
	instanceVariableNames: 'lintRule failedClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!SmallLintMethodFailure class methodsFor: 'instance creation' stamp: 'HAW 11/1/2005 10:56'!
for: aLintRule class: aClass selector: aSymbol 

	^self new initializeFor: aLintRule class: aClass selector: aSymbol ! !

!SmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 12/18/2005 23:45'!
definedEnvironment
	
	^SelectorEnvironment onMethods: (Array with: selector) forClass: failedClass in: BrowserEnvironment new! !

!SmallLintMethodFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 10:58'!
expectedFailureInstanceCreationCodeTemplate

	^self isMethodTextFailure
		ifTrue: [ self expectedMethodTextFailureInstanceCreationCodeTemplate ]
		ifFalse: [ self expectedMethodFailureInstanceCreationCodeTemplate ].
		! !

!SmallLintMethodFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 10:58'!
expectedMethodFailureInstanceCreationCodeTemplate

	| stream |
	
	stream := WriteStream on: String new.
	stream
		nextPutAll: self expectedSmallLintFailureClass name;
		space;
		nextPutAll: self ruleIdentifier asString;
		nextPutAll: 'FailedClass: self failedMethod: ''';
		nextPutAll: selector asString;
		nextPutAll: ''' asSymbol reasonDescription: <aString> definedBy: ''';
		nextPutAll: self userInitials;
		nextPutAll: ''''.

	^stream contents.
		
		! !

!SmallLintMethodFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 11:00'!
expectedMethodTextFailureInstanceCreationCodeTemplate

	| stream |
	
	stream := WriteStream on: String new.
	stream
		nextPutAll: self expectedSmallLintFailureClass name;
		space;
		nextPutAll: self ruleIdentifier asString;
		nextPutAll: ': <Text> failedClass: self failedMethod: ''';
		nextPutAll: selector asString;
		nextPutAll: ''' asSymbol reasonDescription: <aString> definedBy: ''';
		nextPutAll: self userInitials;
		nextPutAll: ''''.

	^stream contents.! !

!SmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:57'!
failedClass

	^failedClass! !

!SmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:57'!
failedMethod

	^selector! !

!SmallLintMethodFailure methodsFor: 'initialization' stamp: 'HAW 11/1/2005 11:00'!
initializeFor: aLintRule class: aClass selector: aSymbol

	lintRule := aLintRule.
	failedClass := aClass.
	selector := aSymbol ! !

!SmallLintMethodFailure methodsFor: 'testing' stamp: 'HAW 11/1/2005 11:00'!
isMethodTextFailure
		
	^self methodTextFailureRuleIdentifiers includes: self ruleIdentifier
! !

!SmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:57'!
methodTextFailureRuleIdentifiers 

	^#(sendsDifferentSuper sentNotImplemented sentNotImplementedInApplication 
	tempsReadBeforeWritten unreferencedTempVar variableReferencedOnce)! !

!SmallLintMethodFailure methodsFor: 'printing' stamp: 'HAW 11/1/2005 11:00'!
printOn: aStream

	aStream
		nextPutAll: failedClass name;
		nextPutAll: '>>';
		nextPutAll: selector;
		nextPutAll: ' - Failure: ';
		nextPutAll: lintRule name
! !

!SmallLintMethodFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 10:57'!
rule

	^lintRule! !

SmallLintFailure subclass: #SmallLintVariableFailure
	instanceVariableNames: 'lintRule failedClass variableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!SmallLintVariableFailure class methodsFor: 'instance creation' stamp: 'HAW 11/1/2005 11:02'!
for: aLintRule class: aClass variableName: aVariableName

	^self new initializeFor: aLintRule class: aClass variableName: aVariableName! !

!SmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 12/18/2005 23:47'!
definedEnvironment
	
	^VariableEnvironment smallLintFailureReferencesToInstanceVariable: variableName in: failedClass! !

!SmallLintVariableFailure methodsFor: 'code generation' stamp: 'HAW 11/1/2005 11:03'!
expectedFailureInstanceCreationCodeTemplate

	| stream |
	
	stream := WriteStream on: String new.
	stream
		nextPutAll: self expectedSmallLintFailureClass name;
		space;
		nextPutAll: self ruleIdentifier asString;
		nextPutAll: 'FailedClass: self failedVariable: ''';
		nextPutAll: variableName;
		nextPutAll: ''' reasonDescription: <aString> definedBy: ''';
		nextPutAll: self userInitials;
		nextPutAll: ''''.

	^stream contents.! !

!SmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:03'!
failedClass

	^failedClass! !

!SmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:03'!
failedVariable

	^variableName! !

!SmallLintVariableFailure methodsFor: 'initialization' stamp: 'HAW 11/1/2005 11:04'!
initializeFor: aLintRule class: aClass variableName: aVariableName

	lintRule := aLintRule.
	failedClass := aClass.
	variableName := aVariableName! !

!SmallLintVariableFailure methodsFor: 'printing' stamp: 'HAW 11/1/2005 11:04'!
printOn: aStream

	aStream
		nextPutAll: failedClass name;
		nextPutAll: ' Variable: ';
		nextPutAll: variableName;
		nextPutAll: ' - Failure ';
		nextPutAll: lintRule name		! !

!SmallLintVariableFailure methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:03'!
rule

	^lintRule! !

Object subclass: #SmallLintFailureChecker
	instanceVariableNames: 'environment rules smallLintFailures failureExplanations notUsedExpectedFailures expectedFailures notExplainedFailures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!SmallLintFailureChecker class methodsFor: 'defaults' stamp: 'HAW 12/18/2005 20:21'!
defaultRules

	^CompositeLintRule lintChecks 

! !

!SmallLintFailureChecker class methodsFor: 'instance creation' stamp: 'HAW 12/17/2005 13:06'!
environment: anEnvironment

	^self rules: self defaultRules environment: anEnvironment! !

!SmallLintFailureChecker class methodsFor: 'instance creation' stamp: 'HAW 12/17/2005 13:07'!
environment: anEnvironment expectedFailures: aCollectionOfExpectedFailures

	^self
		rules: self defaultRules
		environment: anEnvironment
		expectedFailures: aCollectionOfExpectedFailures! !

!SmallLintFailureChecker class methodsFor: 'instance creation' stamp: 'HAW 12/18/2005 14:31'!
rules: aLintRule environment: anEnvironment 
	^self 
		rules: aLintRule
		environment: anEnvironment
		expectedFailures: (ExpectedSmallLintFailuresCollector on: anEnvironment) 
				value! !

!SmallLintFailureChecker class methodsFor: 'instance creation' stamp: 'HAW 12/17/2005 13:09'!
rules: aLintRule environment: anEnvironment expectedFailures: aCollectionOfExpectedFailures 

	^self new initializeRule: aLintRule environment: anEnvironment expectedFailures: aCollectionOfExpectedFailures! !

!SmallLintFailureChecker methodsFor: 'evaluating-private' stamp: 'HAW 12/18/2005 14:32'!
createFailureExplanations
	failureExplanations := OrderedCollection new.
	notUsedExpectedFailures := OrderedCollection withAll: expectedFailures.
	smallLintFailures do: 
			[:aSmallLintFailure | 
			| expectedFailure |
			expectedFailure := notUsedExpectedFailures 
						detect: [:aExpectedFail | aExpectedFail isFor: aSmallLintFailure]
						ifNone: [nil].
			expectedFailure notNil 
				ifTrue: 
					[notUsedExpectedFailures remove: expectedFailure.
					failureExplanations 
						add: (SmallLintFailureExplanation failure: aSmallLintFailure
								explanation: expectedFailure)]]! !

!SmallLintFailureChecker methodsFor: 'evaluating-private' stamp: 'HAW 12/17/2005 13:00'!
createNotExplainedFailures

	notExplainedFailures := smallLintFailures reject: [:aSmallLintFailure | 
		(failureExplanations detect: [:anExplanation | anExplanation isFor: aSmallLintFailure] ifNone: [nil]) notNil]! !

!SmallLintFailureChecker methodsFor: 'evaluating-private' stamp: 'HAW 12/17/2005 13:01'!
createResults

	self createSmallLintFailures.
	self createFailureExplanations.
	self createNotExplainedFailures! !

!SmallLintFailureChecker methodsFor: 'evaluating-private' stamp: 'HAW 12/17/2005 13:01'!
createSmallLintFailures

	smallLintFailures := OrderedCollection new.
	rules failedRules do: [:aFailedRule | smallLintFailures addAll: aFailedRule failures]! !

!SmallLintFailureChecker methodsFor: 'accessing' stamp: 'HAW 12/17/2005 12:59'!
failedRules

	^rules failedRules! !

!SmallLintFailureChecker methodsFor: 'accessing' stamp: 'HAW 12/17/2005 12:59'!
failureExplanations

	^failureExplanations copy! !

!SmallLintFailureChecker methodsFor: 'testing' stamp: 'HAW 12/17/2005 13:02'!
hasNotExplainedFailures

	^notExplainedFailures notEmpty! !

!SmallLintFailureChecker methodsFor: 'testing' stamp: 'HAW 12/17/2005 13:02'!
hasNotUsedExpectedFailures

	^notUsedExpectedFailures notEmpty! !

!SmallLintFailureChecker methodsFor: 'initialization' stamp: 'HAW 12/17/2005 13:01'!
initializeRule: aLintRule environment: anEnvironment expectedFailures: aCollectionOfExpectedFailures 

	rules := aLintRule.
	environment := anEnvironment.
	expectedFailures := aCollectionOfExpectedFailures! !

!SmallLintFailureChecker methodsFor: 'accessing' stamp: 'HAW 12/17/2005 12:59'!
notExplainedFailures

	^notExplainedFailures copy! !

!SmallLintFailureChecker methodsFor: 'accessing' stamp: 'HAW 12/17/2005 12:59'!
notUsedExpectedFailures

	^notUsedExpectedFailures copy! !

!SmallLintFailureChecker methodsFor: 'evaluating-private' stamp: 'HAW 12/17/2005 13:01'!
runSmallLintCheck

	| smallLintChecker |
	
	smallLintChecker := SmalllintChecker new.
	smallLintChecker
		environment: environment;
		rule: rules;
		run! !

!SmallLintFailureChecker methodsFor: 'evaluating' stamp: 'HAW 12/17/2005 13:00'!
value

	self runSmallLintCheck.
	self createResults! !

Object subclass: #SmallLintFailureExplanation
	instanceVariableNames: 'explanation failure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

!SmallLintFailureExplanation class methodsFor: 'instance creation' stamp: 'HAW 12/17/2005 13:12'!
failure: aSmallLintFailure explanation: aExpectedSmallLintFailure 
 
	^self new initializeFailure: aSmallLintFailure explanation: aExpectedSmallLintFailure! !

!SmallLintFailureExplanation methodsFor: 'initialization' stamp: 'HAW 12/17/2005 13:11'!
initializeFailure: aSmallLintFailure explanation: aExpectedSmallLintFailure
 
	failure := aSmallLintFailure.
	explanation := aExpectedSmallLintFailure ! !

!SmallLintFailureExplanation methodsFor: 'testing' stamp: 'HAW 12/17/2005 13:12'!
isFor: aSmallLintFailure 

	^failure = aSmallLintFailure! !

!SmallLintFailureExplanation methodsFor: 'printing' stamp: 'HAW 12/17/2005 13:11'!
printOn: aStream
 
	aStream
		print: failure;
		nextPutAll: ' explanation: ';
		print: explanation! !

Object subclass: #SmallLintRuleInformation
	instanceVariableNames: 'ruleClass ruleIdentifier ruleName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Model'!

SmallLintRuleInformation class
	instanceVariableNames: 'contents'!

!SmallLintRuleInformation class methodsFor: 'initialization' stamp: 'HAW 12/17/2005 13:23'!
initialize

	super initialize.
	self initializeContents! !

!SmallLintRuleInformation class methodsFor: 'initialization' stamp: 'HAW 12/17/2005 13:23'!
initializeContents

	contents := OrderedCollection new.
	self initializeDefaultSmallLintRules.
! !

!SmallLintRuleInformation class methodsFor: 'initialization' stamp: 'HAW 11/1/2005 11:20'!
initializeDefaultSmallLintRules
	BasicLintRule withAllSubclassesDo: [:aClass | 
		BasicLintRule protocols do: [ :aCategoryName |
			(aClass class organization listAtCategoryNamed: aCategoryName) do: [ :aSelector | 
				contents add: (self 
								ruleClass: aClass
								ruleIdentifier: aSelector
								name: (aClass perform: aSelector) name)]]]! !

!SmallLintRuleInformation class methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:06'!
numberOfRules

	^contents size! !

!SmallLintRuleInformation class methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:06'!
ruleClassFor: aSymbol 
	
	^(self ruleInformationFor: aSymbol) ruleClass! !

!SmallLintRuleInformation class methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:06'!
ruleClass: aClass ruleIdentifier: aSymbol name: aString 
	
	^self new initializeRuleClass: aClass ruleIdentifier: aSymbol name: aString ! !

!SmallLintRuleInformation class methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:07'!
ruleFor: aSymbol 
	
	^(self ruleInformationFor: aSymbol) rule! !

!SmallLintRuleInformation class methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:07'!
ruleIdentifierFor: aLintRule 

	^(self ruleInformationForRule: aLintRule) ruleIdentifier! !

!SmallLintRuleInformation class methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:07'!
ruleInformationForRule: aLintRule 

	| ruleName |
	
	ruleName := aLintRule name.
	^contents detect: [ :aRuleInformation | aRuleInformation ruleName = ruleName ]! !

!SmallLintRuleInformation class methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:07'!
ruleInformationFor: aSymbol 
	^contents 
		detect: [:aSmallLintRuleInformation | aSmallLintRuleInformation ruleIdentifier = aSymbol]! !

!SmallLintRuleInformation class methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:07'!
ruleNameFor: aSymbol 

	^(self ruleInformationFor: aSymbol) ruleName! !

!SmallLintRuleInformation class methodsFor: 'accessing' stamp: 'HAW 12/17/2005 13:22'!
selectorsToIgnoreEnvironmentFrom: selectorsToIgnore storeOn: anEnvironment 

	| selectorsExceptionEnvironment |
	
	selectorsExceptionEnvironment := SelectorEnvironment 
				implementorsMatchingAll: selectorsToIgnore
				in: anEnvironment.
				
	^selectorsExceptionEnvironment! !

!SmallLintRuleInformation methodsFor: 'initialization' stamp: 'HAW 11/1/2005 11:45'!
initializeRuleClass: aClass ruleIdentifier: aSymbol name: aString 

	ruleClass := aClass.
	ruleIdentifier := aSymbol.
	ruleName := aString! !

!SmallLintRuleInformation methodsFor: 'printing' stamp: 'HAW 11/1/2005 11:45'!
printOn: aStream

	ruleName printOn: aStream! !

!SmallLintRuleInformation methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:21'!
rule
	
	^ruleClass perform: ruleIdentifier! !

!SmallLintRuleInformation methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:21'!
ruleClass

	^ruleClass! !

!SmallLintRuleInformation methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:21'!
ruleIdentifier

	^ruleIdentifier! !

!SmallLintRuleInformation methodsFor: 'accessing' stamp: 'HAW 11/1/2005 11:21'!
ruleName

	^ruleName! !

Object subclass: #SuperclassOfClassesWithSmallLintErrors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

SuperclassOfClassesWithSmallLintErrors subclass: #ClassWithSmallLintErrors
	instanceVariableNames: 'instanceVariable unreferencedVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

ClassWithSmallLintErrors class
	instanceVariableNames: 'classInstVarNotInitialized'!

!ClassWithSmallLintErrors class methodsFor: 'test' stamp: 'HAW 12/18/2005 15:29'!
classNameInSelectorClassWithSmallLintErrors

	"Do no't erase this method!!!! It is for a small lint test"! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 19:29'!
addRemoveDependents

	self addDependent: self! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:21'!
asOrderedCollectionNotNeeded

	| a |
	
	a := OrderedCollection new.
	a addAll: #(1 2) asOrderedCollection.! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:21'!
assignmentInBlock

	| a |
	
	[ a := 1 ] ensure: [ 1 ].
! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:21'!
assignmentInIfTrue

	| a |

	true ifTrue: [ a := 1 ] ifFalse: [ a:= 2 ].	
! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:23'!
atIfAbsent

	| a |
	
	a at: 1 ifAbsent: [ a at: 1 put: 2 ].
	! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:21'!
badMessage

	self halt! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:22'!
booleanPrecedence

	^1 | 2 = 3! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:22'!
collectionMessagesToExternalObject

	| a |
	
	(a pepe: 1) add: 2.! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:23'!
collectionProtocol

	| a b |
	
	a do: [ :x | b add: x ].! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:23'!
collectSelectNotUsed

	| a |
	
	a select: [ :x | x ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:23'!
consistencyCheck

	| a |
	
	a size=0 ifTrue: [ 1 ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 16:55'!
contains

	| a | 
	
	^(a detect: [ :b | b = 1 ] ifNone: [nil])=nil! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:23'!
detects

	| a |
	
	a do: [ :x | x=0 ifTrue: [ ^x ] ].! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:24'!
endTrueFalse

	| a |
	
	a ifTrue: [ 1 + 1 ] ifFalse: [ 1 + 1 ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:24'!
equalNotUsed

	1 = 2! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:24'!
equalsTrue

	| a |
	
	^a = true! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:24'!
equivalentSuperclassMethods

	^10! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:24'!
extraBlock

	[ 1 ] value! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:24'!
fileBlocks

	| a |
	
	[ a := self ] ensure: [ a close ].! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 19:31'!
fullBlocks

	^[thisContext]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:25'!
guardingClause

	true ifTrue: [ 
		1 + 1.
		2 + 2.
		3 + 3 ]
	! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:28'!
ifTrueBlocks

	| a |
	
	true ifTrue: a! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:28'!
ifTrueReturns

	true ifTrue: [ ^true ].
	^false! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:28'!
implementedNotSent1

	^self! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:28'!
justSendsSuper

	^super justSendsSuper! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:28'!
literalArrayCharacters

	#($a $b $c)! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:29'!
literalArrayContainsComma

	
	self literalArrayContainsComma.
	self printOn: #(a , b).! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 19:40'!
literalArrayContainsSuspiciousTrueFalseOrNil

	{#true. #false. #nil}! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:29'!
longMethods

	1+1.
	1+1.
	1+1.
	1+1.
	1+1.
	1+1.
	1+1.
	1+1.
	1+1.
	1+1.
	1+1.
	1+1.
! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:29'!
minMax

	1 < 2  ifTrue: [1] ifFalse: [2]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:29'!
missingSubclassResponsibility

	^1! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:29'!
missingYourself

	| a |
	
	a := OrderedCollection new
		add: 1;
		remove: 1.! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:29'!
modifiesCollection

	| a |
	
	a do: [ :each | a add: 1 ].! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:30'!
precedence

	| a b c |
	
	a + b * c.! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/18/2005 14:37'!
refersToClass
	ClassWithSmallLintErrors new! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:30'!
release

	1 printString

	! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:30'!
returnInEnsure

	[ self ] ensure: [ ^10 ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:30'!
returnsBooleanAndOther

	| a |
	
	a := 10.
	a ifTrue: [ ^true ] ifFalse: [ self ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:30'!
returnsIfTrue

	^1 ifTrue: [ 10 ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:30'!
searchingLiteral

	| a |
	
	a = #pepe or: [ a=#juan ].! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:31'!
sendsDifferentSuper

	super printString! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 19:56'!
sendsUnknownMessageToGlobal

	Object sendsUnknownMessageToGlobal! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:31'!
sentNotImplemented

	self xxxyyy! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:31'!
sizeCheck

	| a |
	
	a size > 0 ifTrue: [ a do: [ :x | x + 1 ] ].! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:31'!
stringConcatenation

	| a |
	
	a do: [ :x | x, 'hello' ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:32'!
tempsReadBeforeWritten

	| a |
	
	a printString.! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:32'!
threeElementPoint

	^1 @ 2 + 3 @ 4! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:32'!
toDo

	| a |
	
	1 to: a size do: [ :x | a at: x  ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:32'!
toDoCollect

	| a |
	
	a := Array new: 10.
	1 to: 10 do: [ :x | a at: x put: x ].! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:32'!
toDoWithIncrement

	1 to: 10 do: [ :x | | a | a := a + 1 ].! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:32'!
unnecessaryAssignment

	| a |
	
	^a := 1! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:33'!
unoptimizedAndOr

	| a b c |
	
	(a and: [ b ]) and: [ c ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:33'!
unoptimizedToDo

	(1 to: 10) do: [ :x | x + 1 ]! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:33'!
usesAdd

	| a |

	a := OrderedCollection new add: 1.
! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:34'!
usesTrue

	| a |

	a := 1.
	a = True.! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 17:37'!
utilityMethods: a

	^a + 1! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/18/2005 12:26'!
variableNotDefined

	"This method has to be correctly defined when the small lint rule starts to work - Hernan"! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:34'!
variableReferencedOnce

	instanceVariable := 10! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:34'!
whileTrue

	| a |
	
	[ a < 10 ] whileTrue: [ a := a + 1 ].! !

!ClassWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:34'!
yourselfNotUsed

	| a |
	
	a add: 1; yourself.! !

!ClassWithSmallLintErrors methodsFor: 'comparing' stamp: 'HAW 12/17/2005 15:20'!
= anObject

	^true! !

!ClassWithSmallLintErrors methodsFor: 'comparing' stamp: 'HAW 12/17/2005 15:21'!
== anObject

	^super == anObject and: [ true ]! !

SuperclassOfClassesWithSmallLintErrors subclass: #ClassWithSmallLintErrors2
	instanceVariableNames: 'instanceVariableToOverride'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!ClassWithSmallLintErrors2 methodsFor: 'test' stamp: 'HAW 12/17/2005 15:38'!
missingSubclassResponsibility

	^2! !

!ClassWithSmallLintErrors2 methodsFor: 'as yet unclassified' stamp: 'HAW 12/17/2005 20:04'!
tempVarOverridesInstVar

	| instanceVariableToOverride |
	
	instanceVariableToOverride := 10.
	^instanceVariableToOverride! !

ClassWithSmallLintErrors2 subclass: #ClassWithSmallLintErrors3
	instanceVariableNames: 'instanceVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

ClassWithSmallLintErrors2 subclass: #ClassWithSmallLintErrors4
	instanceVariableNames: 'instanceVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!SuperclassOfClassesWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:19'!
equivalentSuperclassMethods

	^10! !

!SuperclassOfClassesWithSmallLintErrors methodsFor: 'test' stamp: 'HAW 12/17/2005 15:19'!
subclassResponsibilityNotDefined

	self subclassResponsibility! !

!Class methodsFor: '*small lint failure-model' stamp: 'HAW 12/17/2005 12:55'!
expectedSmallLintFailures

	^#()! !

!Class methodsFor: '*small lint failure-model' stamp: 'HAW 12/17/2005 11:19'!
inheritedExpectedSmallLintFailures

	^#()! !

TestCase subclass: #ExpectedSmallLintClassFailureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!ExpectedSmallLintClassFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 12:42'!
failureForAnotherClassForTesting
	| reason failedClass ruleIdentifier userName |
	ruleIdentifier := #classNotReferenced.
	reason := 'Another Test reason'.
	userName := 'Another Test user'.
	failedClass := Number.
	^ExpectedSmallLintClassFailure 
		forRule: ruleIdentifier
		failedClass: failedClass
		reasonDescription: reason
		definedBy: userName! !

!ExpectedSmallLintClassFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 12:42'!
firstFailureForTesting
	| failedClass reason ruleName userName |
	failedClass := Object.
	ruleName := #overridesSpecialMessage.
	reason := 'Test reason'.
	userName := 'Test user'.
	^ExpectedSmallLintClassFailure 
		forRule: ruleName
		failedClass: failedClass
		reasonDescription: reason
		definedBy: userName! !

!ExpectedSmallLintClassFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 12:42'!
secondFailureForTesting
	| reason failedClass ruleIdentifier userName |
	ruleIdentifier := #overridesSpecialMessage.
	reason := 'Another Test reason'.
	userName := 'Another Test user'.
	failedClass := Object.
	^ExpectedSmallLintClassFailure 
		forRule: ruleIdentifier
		failedClass: failedClass
		reasonDescription: reason
		definedBy: userName! !

!ExpectedSmallLintClassFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 12:42'!
testClassToSearchSendersOn
	| failure ruleName failedClass reason userName |
	ruleName := #ruleName.
	failedClass := Object.
	reason := 'Test reason'.
	userName := 'TestUser'.
	failure := ExpectedSmallLintClassFailure 
				forRule: ruleName
				failedClass: failedClass
				reasonDescription: reason
				definedBy: userName.
	self assert: failure classToSearchSendersOn = failedClass! !

!ExpectedSmallLintClassFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 15:27'!
testCodeToSearchExpectedFailure
	| failure ruleName failedClass reason userName |
	ruleName := #ruleName.
	failedClass := Object.
	reason := 'Test reason'.
	userName := 'TestUser'.
	failure := ExpectedSmallLintClassFailure 
				forRule: ruleName
				failedClass: failedClass
				reasonDescription: reason
				definedBy: userName.
	self assert: failure codeToSearchExpectedFailure 
				= ('ExpectedSmallLintClassFailure browseExpectedFailuresFor: ''' 
						, ruleName asString , 'FailedClass:*'' in: ' 
						, failedClass name asString)! !

!ExpectedSmallLintClassFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 12:42'!
testInstanceCreation
	| failure ruleName failedClass reason userName |
	ruleName := #overridesSpecialMessage.
	failedClass := Object.
	reason := 'Test reason'.
	userName := 'Test user'.
	failure := ExpectedSmallLintClassFailure 
				forRule: ruleName
				failedClass: failedClass
				reasonDescription: reason
				definedBy: userName.
	self
		assert: failure failedClass = failedClass;
		assert: failure ruleIdentifier = ruleName;
		assert: failure printString notNil! !

!ExpectedSmallLintClassFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 12:42'!
testSendersPattern
	| failure ruleName failedClass reason userName |
	ruleName := #ruleName.
	failedClass := Object.
	reason := 'Test reason'.
	userName := 'TestUser'.
	failure := ExpectedSmallLintClassFailure 
				forRule: ruleName
				failedClass: failedClass
				reasonDescription: reason
				definedBy: userName.
	self assert: failure sendersPattern = (ruleName , 'FailedClass:*')! !

TestCase subclass: #ExpectedSmallLintFailuresCollectorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!ExpectedSmallLintFailuresCollectorTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
testValue
	"This is not a great test... - Hernan"

	| collector env expectedFailures |
	env := BrowserEnvironment new forClasses: (Array with: self class).
	collector := ExpectedSmallLintFailuresCollector on: env.
	expectedFailures := collector value.
	self assert: expectedFailures notEmpty! !

TestCase subclass: #ExpectedSmallLintFailureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!ExpectedSmallLintFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:28'!
classFailureMethodCategory
	
	^'instance creation - class fails'! !

!ExpectedSmallLintFailureTest methodsFor: 'accessing' stamp: 'HAW 12/18/2005 14:31'!
failureSelectors
	^ExpectedSmallLintFailure class selectors! !

!ExpectedSmallLintFailureTest methodsFor: 'testing' stamp: 'HAW 12/18/2005 14:31'!
isClassFailureSelector: aSymbol 
	^(ExpectedSmallLintFailure class organization categoryOfElement: aSymbol) 
		includes: self classFailureMethodCategory! !

!ExpectedSmallLintFailureTest methodsFor: 'testing' stamp: 'HAW 12/18/2005 14:31'!
isMethodFailureSelector: aSymbol 
	^(ExpectedSmallLintFailure class organization categoryOfElement: aSymbol) 
		includes: self methodFailureMethodCategory! !

!ExpectedSmallLintFailureTest methodsFor: 'testing' stamp: 'HAW 12/18/2005 14:31'!
isMethodTextFailureSelector: aSymbol 
	^(ExpectedSmallLintFailure class organization categoryOfElement: aSymbol) 
		includes: self methodTextFailureMethodCategory! !

!ExpectedSmallLintFailureTest methodsFor: 'testing' stamp: 'HAW 12/18/2005 14:31'!
isVariableFailureSelector: aSymbol 
	^(ExpectedSmallLintFailure class organization categoryOfElement: aSymbol) 
		includes: self variableFailureMethodCategory! !

!ExpectedSmallLintFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:28'!
methodFailureMethodCategory
	
	^'instance creation - method fails'! !

!ExpectedSmallLintFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:28'!
methodTextFailureMethodCategory
	
	^'instance creation - method text fails'! !

!ExpectedSmallLintFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:33'!
runTestForClassFailureSelector: aSymbol 
	| failedClass reasonDescription definer expectedFailure |
	failedClass := Object.
	reasonDescription := 'Test reason'.
	definer := 'Definer'.
	expectedFailure := ExpectedSmallLintFailure 
				perform: aSymbol
				with: failedClass
				with: reasonDescription
				with: definer.
	self
		assert: expectedFailure failedClass = failedClass;
		assert: expectedFailure reasonDescription = reasonDescription;
		assert: expectedFailure definedBy = definer;
		assert: expectedFailure ruleIdentifier 
					= (SmallLintRuleInformation ruleIdentifierFor: expectedFailure rule);
		assert: expectedFailure rule name 
					= (SmallLintRuleInformation ruleFor: expectedFailure ruleIdentifier) name! !

!ExpectedSmallLintFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
runTestForMethodFailureSelector: aSymbol 
	| failedClass failedMethod reasonDescription definer expectedFailure |
	failedClass := Object.
	failedMethod := #runTestForMethodFailureSelector:.
	reasonDescription := 'Test reason'.
	definer := 'Definer'.
	expectedFailure := ExpectedSmallLintFailure perform: aSymbol
				withArguments: (Array 
						with: failedClass
						with: failedMethod
						with: reasonDescription
						with: definer).
	self
		assert: expectedFailure failedClass = failedClass;
		assert: expectedFailure failedMethod = failedMethod;
		assert: expectedFailure reasonDescription = reasonDescription;
		assert: expectedFailure definedBy = definer! !

!ExpectedSmallLintFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
runTestForMethodTextFailureSelector: aSymbol 
	| failedClass failedMethod failedSelector reasonDescription definer expectedFailure |
	failedClass := Object.
	failedSelector := #runTestForMethodTextFailureSelector:.
	failedMethod := #value.
	reasonDescription := 'Test reason'.
	definer := 'Definer'.
	expectedFailure := ExpectedSmallLintFailure perform: aSymbol
				withArguments: ((OrderedCollection new)
						add: failedSelector;
						add: failedClass;
						add: failedMethod;
						add: reasonDescription;
						add: definer;
						yourself) asArray.
	self
		assert: expectedFailure failedClass = failedClass;
		assert: expectedFailure failedMethod = failedMethod;
		assert: expectedFailure reasonDescription = reasonDescription;
		assert: expectedFailure definedBy = definer! !

!ExpectedSmallLintFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
runTestForVariableFailureSelector: aSymbol 
	| failedClass failedVariableName reasonDescription definer expectedFailure |
	failedClass := Object.
	failedVariableName := 'name'.
	reasonDescription := 'Test reason'.
	definer := 'Definer'.
	expectedFailure := ExpectedSmallLintFailure perform: aSymbol
				withArguments: (Array 
						with: failedClass
						with: failedVariableName
						with: reasonDescription
						with: definer).
	self
		assert: expectedFailure failedClass = failedClass;
		assert: expectedFailure variableName = failedVariableName;
		assert: expectedFailure reasonDescription = reasonDescription;
		assert: expectedFailure definedBy = definer! !

!ExpectedSmallLintFailureTest methodsFor: 'test' stamp: 'HAW 11/1/2005 16:29'!
runTestFor: selector

	(self isMethodTextFailureSelector: selector)
		ifTrue: [^self runTestForMethodTextFailureSelector: selector].

	(self isVariableFailureSelector: selector)
		ifTrue: [^self runTestForVariableFailureSelector: selector].

	(self isClassFailureSelector: selector) 
		ifTrue: [^self runTestForClassFailureSelector: selector].

	(self isMethodFailureSelector: selector)
		ifTrue: [^self runTestForMethodFailureSelector: selector]! !

!ExpectedSmallLintFailureTest methodsFor: 'test' stamp: 'HAW 11/1/2005 16:33'!
testFailureCreation

	self failureSelectors do: [:selector | self runTestFor: selector]! !

!ExpectedSmallLintFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:28'!
variableFailureMethodCategory
	
	^'instance creation - variable fails'! !

TestCase subclass: #ExpectedSmallLintMethodFailureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!ExpectedSmallLintMethodFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:39'!
failedClass

	^Object! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:40'!
failedSelector

	^#failedSelector! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
failureForAnotherClass
	| anotherFailedClass |
	anotherFailedClass := Number.
	^ExpectedSmallLintMethodFailure 
		forRule: #otherRule
		failedClass: anotherFailedClass
		failedMethod: self failedSelector
		reasonDescription: 'Another reason'
		definedBy: 'Another user'! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
failureForAnotherMethodOfSameClass
	^ExpectedSmallLintMethodFailure 
		forRule: #otherRule
		failedClass: self failedClass
		failedMethod: #anotherFailedSelector
		reasonDescription: 'Another reason'
		definedBy: 'Another user'! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
failureForAnotherRuleOfSameClass
	^ExpectedSmallLintMethodFailure 
		forRule: #otherRule
		failedClass: self failedClass
		failedMethod: self failedSelector
		reasonDescription: 'Another reason'
		definedBy: 'Another user'! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:40'!
reason

	^'Test reason'! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:40'!
ruleName

	^#refersToClass! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 15:25'!
testCodeToSearchExpectedFailure
	| failure |
	failure := ExpectedSmallLintMethodFailure 
				forRule: self ruleName
				failedClass: self failedClass
				failedMethod: self failedSelector
				reasonDescription: self reason
				definedBy: self userName.
	self assert: failure codeToSearchExpectedFailure 
				= ('ExpectedSmallLintMethodFailure browseExpectedFailuresFor: ''' 
						, self ruleName asString , 'FailedClass:*'' in: ' 
						, self failedClass name asString)! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
testDefinedEnvironment
	| failure |
	failure := ExpectedSmallLintMethodFailure 
				forRule: self ruleName
				failedClass: self failedClass
				failedMethod: self failedSelector
				reasonDescription: self reason
				definedBy: self userName.
	self
		assert: failure failedClass = self failedClass;
		assert: failure failedMethod = self failedSelector;
		assert: failure ruleIdentifier = self ruleName;
		assert: (failure definedEnvironment includesClass: self failedClass);
		assert: failure printString notNil! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
testInstanceCreation
	| failure |
	failure := ExpectedSmallLintMethodFailure 
				forRule: self ruleName
				failedClass: self failedClass
				failedMethod: self failedSelector
				reasonDescription: self reason
				definedBy: self userName.
	self
		assert: failure failedClass = self failedClass;
		assert: failure failedMethod = self failedSelector;
		assert: failure ruleIdentifier = self ruleName;
		assert: failure printString notNil! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
testIsForSameFailure
	| failure failureForAnotherRuleOfSameClass failureForAnotherClass failureForAnotherMethod |
	failure := ExpectedSmallLintMethodFailure 
				forRule: self ruleName
				failedClass: self failedClass
				failedMethod: self failedSelector
				reasonDescription: self reason
				definedBy: self userName.
	failureForAnotherRuleOfSameClass := self failureForAnotherRuleOfSameClass.
	failureForAnotherClass := self failureForAnotherClass.
	failureForAnotherMethod := self failureForAnotherMethodOfSameClass.
	self
		assert: (failure isForSameFailure: failureForAnotherRuleOfSameClass);
		deny: (failure isForSameFailure: failureForAnotherClass);
		deny: (failure isForSameFailure: failureForAnotherMethod)! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
testSendersPattern
	| failure |
	failure := ExpectedSmallLintMethodFailure 
				forRule: self ruleName
				failedClass: self failedClass
				failedMethod: self failedSelector
				reasonDescription: self reason
				definedBy: self userName.
	self assert: failure sendersPattern = (self ruleName , 'FailedClass:*')! !

!ExpectedSmallLintMethodFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:40'!
userName

	^'usuario'! !

TestCase subclass: #ExpectedSmallLintMethodTextFailureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!ExpectedSmallLintMethodTextFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 15:27'!
testCodeToSearchExpectedFailure
	| failure ruleName failedClass failedMethod invalidText reason userName |
	ruleName := #testRule.
	failedClass := Object.
	failedMethod := #failedSelector.
	invalidText := 'Invalid'.
	reason := 'Test reason'.
	userName := 'User'.
	failure := ExpectedSmallLintMethodTextFailure 
				forRule: ruleName
				failedClass: failedClass
				failedMethod: failedMethod
				invalidText: invalidText
				reasonDescription: reason
				definedBy: userName.
	self assert: failure codeToSearchExpectedFailure 
				= ('ExpectedSmallLintMethodTextFailure browseExpectedFailuresFor: ''' 
						, ruleName asString , ':*'' in: ' 
						, failedClass name asString)! !

!ExpectedSmallLintMethodTextFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
testInstanceCreation
	| failure ruleName failedClass failedMethod invalidText reason userName |
	ruleName := #abstractClass.
	failedClass := Object.
	failedMethod := #failedSelector.
	invalidText := 'Invalid'.
	reason := 'Test reason'.
	userName := 'User'.
	failure := ExpectedSmallLintMethodTextFailure 
				forRule: ruleName
				failedClass: failedClass
				failedMethod: failedMethod
				invalidText: invalidText
				reasonDescription: reason
				definedBy: userName.
	self
		assert: failure ruleIdentifier = ruleName;
		assert: failure failedClass = failedClass;
		assert: failure failedMethod = failedMethod;
		assert: failure invalidText = invalidText;
		assert: failure reasonDescription = reason;
		assert: failure printString notNil! !

!ExpectedSmallLintMethodTextFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:31'!
testSendersPattern
	| failure ruleName failedClass failedMethod invalidText reason userName |
	ruleName := #testRule.
	failedClass := Object.
	failedMethod := #failedSelector.
	invalidText := 'Invalid'.
	reason := 'Test reason'.
	userName := 'User'.
	failure := ExpectedSmallLintMethodTextFailure 
				forRule: ruleName
				failedClass: failedClass
				failedMethod: failedMethod
				invalidText: invalidText
				reasonDescription: reason
				definedBy: userName.
	self assert: failure sendersPattern = (ruleName , ':*')! !

TestCase subclass: #ExpectedSmallLintVariableFailureTest
	instanceVariableNames: 'failedVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!ExpectedSmallLintVariableFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:45'!
failedClass
	^self! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:45'!
failedVariable
	^'failedVariable'! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:32'!
failureForAnotherClass
	| anotherFailedClass |
	anotherFailedClass := Object.
	^ExpectedSmallLintVariableFailure 
		forRule: #otherRule
		failedClass: anotherFailedClass
		failedVariable: self failedVariable
		reasonDescription: 'Another reason'
		definedBy: 'Another user'! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:32'!
failureForAnotherRuleOfSameClassAndSameVariable
	^ExpectedSmallLintVariableFailure 
		forRule: #otherRule
		failedClass: self failedClass
		failedVariable: self failedVariable
		reasonDescription: 'Another reason'
		definedBy: 'Another user'! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:32'!
failureForAnotherVariable
	^ExpectedSmallLintVariableFailure 
		forRule: #otherRule
		failedClass: self failedClass
		failedVariable: 'anotherFailedVariable'
		reasonDescription: 'Another reason'
		definedBy: 'Another user'! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:45'!
reason
	^'Test reason'! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:45'!
ruleName

	^#variableReferencedOnce! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 15:24'!
testCodeToSearchExpectedFailure
	| failure ruleName failedClass failedVar reason userName |
	ruleName := #overridesSpecialMessage.
	failedClass := self class.
	failedVar := 'failedVariable'.
	reason := 'Test reason'.
	userName := 'user'.
	failure := ExpectedSmallLintVariableFailure 
				forRule: ruleName
				failedClass: failedClass
				failedVariable: failedVar
				reasonDescription: reason
				definedBy: userName.
	self assert: failure codeToSearchExpectedFailure 
				= ('ExpectedSmallLintVariableFailure browseExpectedFailuresFor: ''' 
						, ruleName asString , 'FailedClass:*'' in: ' 
						, failedClass name asString)! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:32'!
testDefinedEnvironment
	| failure ruleName failedClass reason userName |
	ruleName := #overridesSpecialMessage.
	failedClass := self class.
	failedVariable := 'failedVariable'.
	reason := 'Test reason'.
	userName := 'user'.
	failure := ExpectedSmallLintVariableFailure 
				forRule: ruleName
				failedClass: failedClass
				failedVariable: failedVariable
				reasonDescription: reason
				definedBy: userName.
	self assert: (failure definedEnvironment includesClass: failedClass)! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:32'!
testInstanceCreation
	| failure ruleName failedClass failedVariable reason userName |
	ruleName := #overridesSpecialMessage.
	failedClass := self class.
	failedVariable := 'failedVariable'.
	reason := 'Test reason'.
	userName := 'usuario'.
	failure := ExpectedSmallLintVariableFailure 
				forRule: ruleName
				failedClass: failedClass
				failedVariable: failedVariable
				reasonDescription: reason
				definedBy: userName.
	self
		assert: failure failedClass = failedClass;
		assert: failure failedVariable = failedVariable;
		assert: failure ruleIdentifier = ruleName;
		assert: failure printString notNil! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:32'!
testIsForSameFailure
	| failure anotherFailure failureForAnotherClass failureForAnotherVariable |
	failure := ExpectedSmallLintVariableFailure 
				forRule: self ruleName
				failedClass: self failedClass
				failedVariable: self failedVariable
				reasonDescription: self reason
				definedBy: self userName.
	anotherFailure := self failureForAnotherRuleOfSameClassAndSameVariable.
	failureForAnotherClass := self failureForAnotherClass.
	failureForAnotherVariable := self failureForAnotherVariable.
	self
		assert: (failure isForSameFailure: anotherFailure);
		deny: (failure isForSameFailure: failureForAnotherClass);
		deny: (failure isForSameFailure: failureForAnotherVariable)! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:32'!
testSendersPattern
	| failure ruleName failedClass failedVariable reason userName |
	ruleName := #overridesSpecialMessage.
	failedClass := self class.
	failedVariable := 'failedVariable'.
	reason := 'Test reason'.
	userName := 'usuario'.
	failure := ExpectedSmallLintVariableFailure 
				forRule: ruleName
				failedClass: failedClass
				failedVariable: failedVariable
				reasonDescription: reason
				definedBy: userName.
	self assert: failure sendersPattern = (ruleName , 'FailedClass:*')! !

!ExpectedSmallLintVariableFailureTest methodsFor: 'accessing' stamp: 'HAW 11/1/2005 16:45'!
userName

	^'TestUser'! !

TestCase subclass: #SmallLintClassFailureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!SmallLintClassFailureTest methodsFor: 'initialization' stamp: 'HAW 12/18/2005 14:33'!
setUp
	SmallLintRuleInformation initialize! !

!SmallLintClassFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 15:32'!
testExpectedFailureInstanceCreationCodeTemplate
	| failure lintRule failedClass expectedCodeTemplate |
	expectedCodeTemplate := 'ExpectedSmallLintFailure classNotReferencedFailedClass: self class reasonDescription: <aString> definedBy: ''' 
				, Utilities authorInitials , ''''.
	lintRule := MockLintRule named: 'Class not referenced'.
	failedClass := Object.
	failure := SmallLintClassFailure for: lintRule in: failedClass.
	self assert: failure expectedFailureInstanceCreationCodeTemplate 
				= expectedCodeTemplate! !

!SmallLintClassFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:32'!
testInstanceCreation
	| failure lintRule failedClass |
	lintRule := self.
	failedClass := Object.
	failure := SmallLintClassFailure for: lintRule in: failedClass.
	self
		assert: failure rule = lintRule;
		assert: failure failedClass = failedClass;
		assert: failure printString notNil;
		assert: failure ruleName = lintRule name! !

TestCase subclass: #SmallLintFailureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!SmallLintFailureTest class methodsFor: 'accessing' stamp: 'HAW 12/17/2005 16:28'!
allTestSelectors

	^(self organization categories select: [:aCategoryName | 'test -*' match: aCategoryName]) 
		inject: OrderedCollection new into: [:selectors :aCategoryName | selectors addAll: (self allMethodsInCategory: aCategoryName); yourself]
				
! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:36'!
abstractClass
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				abstractClassFailedClass: SuperclassOfClassesWithSmallLintErrors
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
addRemoveDependents
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				addRemoveDependentsFailedClass: ClassWithSmallLintErrors
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
asOrderedCollectionNotNeeded
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				asOrderedCollectionNotNeededFailedClass: ClassWithSmallLintErrors
				failedMethod: #asOrderedCollectionNotNeeded
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'utilities' stamp: 'HAW 12/17/2005 15:58'!
assertExpectedFailure: anExpectedSmallLintFailure
 
	self 
		assertRule: anExpectedSmallLintFailure rule
		onEnvironment: anExpectedSmallLintFailure definedEnvironment
		expectedFailures: (Array with: anExpectedSmallLintFailure)! !

!SmallLintFailureTest methodsFor: 'utilities' stamp: 'HAW 12/18/2005 14:32'!
assertRule: aLintRule onEnvironment: anEnvironment expectedFailures: expectedFailures 
	| checker |
	checker := SmallLintFailureChecker 
				rules: aLintRule
				environment: anEnvironment
				expectedFailures: expectedFailures.
	checker value.
	self assert: checker notExplainedFailures isEmpty.
	self assert: checker notUsedExpectedFailures isEmpty! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
assignmentInBlock
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				assignmentInBlockFailedClass: ClassWithSmallLintErrors
				failedMethod: #assignmentInBlock
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
assignmentInIfTrue
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				assignmentInIfTrueFailedClass: ClassWithSmallLintErrors
				failedMethod: #assignmentInIfTrue
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
atIfAbsent
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				atIfAbsentFailedClass: ClassWithSmallLintErrors
				failedMethod: #atIfAbsent
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
badMessage
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				badMessageFailedClass: ClassWithSmallLintErrors
				failedMethod: #badMessage
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - bugs' stamp: 'HAW 12/18/2005 14:37'!
booleanPrecedence
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				booleanPrecedenceFailedClass: ClassWithSmallLintErrors
				failedMethod: #booleanPrecedence
				reasonDescription: 'For testing reason'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
classInstVarNotInitialized
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				classInstVarNotInitializedFailedClass: ClassWithSmallLintErrors class
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 15:30'!
classNameInSelector
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				classNameInSelectorFailedClass: ClassWithSmallLintErrors class
				failedMethod: #classNameInSelectorClassWithSmallLintErrors
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:31'!
classNotReferenced
	| expectedFails |
	expectedFails := Array with: (ExpectedSmallLintFailure 
						classNotReferencedFailedClass: self class
						reasonDescription: 'For testing porpouses'
						definedBy: 'Hernan')
				with: (ExpectedSmallLintFailure 
						classNotReferencedFailedClass: self class class
						reasonDescription: 'For testing porpouses'
						definedBy: 'Hernan').
	self 
		assertRule: BlockLintRule classNotReferenced
		onEnvironment: expectedFails first definedEnvironment
		expectedFailures: expectedFails! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
collectionMessagesToExternalObject
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				collectionMessagesToExternalObjectFailedClass: ClassWithSmallLintErrors
				failedMethod: #collectionMessagesToExternalObject
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
collectionProtocol
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				collectionProtocolFailedClass: ClassWithSmallLintErrors
				failedMethod: #collectionProtocol
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
collectSelectNotUsed
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				collectSelectNotUsedFailedClass: ClassWithSmallLintErrors
				failedMethod: #collectSelectNotUsed
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
consistencyCheck
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				consistencyCheckFailedClass: ClassWithSmallLintErrors
				failedMethod: #consistencyCheck
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
contains
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				containsFailedClass: ClassWithSmallLintErrors
				failedMethod: #contains
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
definesEqualNotHash
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				definesEqualNotHashFailedClass: ClassWithSmallLintErrors
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
detects
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				detectContainsFailedClass: ClassWithSmallLintErrors
				failedMethod: #detects
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
endTrueFalse
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				endTrueFalseFailedClass: ClassWithSmallLintErrors
				failedMethod: #endTrueFalse
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
equalNotUsed
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				equalNotUsedFailedClass: ClassWithSmallLintErrors
				failedMethod: #equalNotUsed
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
equalsTrue
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				equalsTrueFailedClass: ClassWithSmallLintErrors
				failedMethod: #equalsTrue
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
equivalentSuperclassMethods
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				equivalentSuperclassMethodsFailedClass: ClassWithSmallLintErrors
				failedMethod: #equivalentSuperclassMethods
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
extraBlock
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				extraBlockFailedClass: ClassWithSmallLintErrors
				failedMethod: #extraBlock
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
fileBlocks
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				fileBlocksFailedClass: ClassWithSmallLintErrors
				failedMethod: #fileBlocks
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
fullBlocks
	"This small lint rule is not implemented, even though, I provide a expected failure so when it gets implemented this test
	will fail. If that happens, just erase the message on:do: to make it work - Hernan"

	
	[self assertExpectedFailure: (ExpectedSmallLintFailure 
				fullBlocksFailedClass: ClassWithSmallLintErrors
				failedMethod: #fullBlocks
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan').
	self 
		error: 'It should not get here. If it does, it means that the rule is working and the test has to be chaned'] 
			on: TestResult failure
			do: [:anException | anException return]! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
guardingClause
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				guardingClauseFailedClass: ClassWithSmallLintErrors
				failedMethod: #guardingClause
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
ifTrueBlocks
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				ifTrueBlocksFailedClass: ClassWithSmallLintErrors
				ifTrueBlocks: #ifTrueBlocks
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
ifTrueReturns
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				ifTrueReturnsFailedClass: ClassWithSmallLintErrors
				failedMethod: #ifTrueReturns
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
implementedNotSent
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				implementedNotSentFailedClass: ClassWithSmallLintErrors
				failedMethod: 'implementedNotSent1' asSymbol
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:38'!
instVarInSubclasses
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				instVarInSubclassesFailedClass: ClassWithSmallLintErrors2
				failedVariable: 'instanceVariable'
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
justSendsSuper
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				justSendsSuperFailedClass: ClassWithSmallLintErrors
				failedMethod: #justSendsSuper
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
literalArrayCharacters
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				literalArrayCharactersFailedClass: ClassWithSmallLintErrors
				failedMethod: #literalArrayCharacters
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
literalArrayContainsComma
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				literalArrayContainsCommaFailedClass: ClassWithSmallLintErrors
				failedMethod: #literalArrayContainsComma
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
literalArrayContainsSuspiciousTrueFalseOrNil
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				literalArrayContainsSuspiciousTrueFalseOrNilFailedClass: ClassWithSmallLintErrors
				failedMethod: #literalArrayContainsSuspiciousTrueFalseOrNil
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
longMethods
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				longMethodsFailedClass: ClassWithSmallLintErrors
				failedMethod: #longMethods
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
minMax
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				minMaxFailedClass: ClassWithSmallLintErrors
				failedMethod: #minMax
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:36'!
missingSubclassResponsibility
	self assertExpectedFailure: (ExpectedSmallLintClassFailure 
				forRule: #missingSubclassResponsibility
				failedClass: SuperclassOfClassesWithSmallLintErrors
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
missingYourself
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				missingYourselfFailedClass: ClassWithSmallLintErrors
				failedMethod: #missingYourself
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
modifiesCollection
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				modifiesCollectionFailedClass: ClassWithSmallLintErrors
				failedMethod: #modifiesCollection
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
onlyReadOrWritten
	| expectedFails |
	expectedFails := Array with: (ExpectedSmallLintFailure 
						onlyReadOrWrittenFailedClass: ClassWithSmallLintErrors
						failedVariable: 'instanceVariable'
						reasonDescription: 'For testing porpouses'
						definedBy: 'Hernan')
				with: (ExpectedSmallLintFailure 
						onlyReadOrWrittenFailedClass: ClassWithSmallLintErrors
						failedVariable: 'unreferencedVariable'
						reasonDescription: 'For testing porpouses'
						definedBy: 'Hernan').
	self 
		assertRule: BlockLintRule onlyReadOrWritten
		onEnvironment: expectedFails first definedEnvironment
		expectedFailures: expectedFails! !

!SmallLintFailureTest methodsFor: 'test - bugs' stamp: 'HAW 12/18/2005 14:37'!
overridesSpecialMessage
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				overridesSpecialMessageFailedClass: ClassWithSmallLintErrors
				reasonDescription: 'For testing reason'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
overridesSuper
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				overridesSuperFailedClass: ClassWithSmallLintErrors
				failedMethod: #equivalentSuperclassMethods
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
precedence
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				precedenceFailedClass: ClassWithSmallLintErrors
				failedMethod: #precedence
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
refersToClass
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				refersToClassFailedClass: ClassWithSmallLintErrors
				failedMethod: #refersToClass
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
returnInEnsure
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				returnInEnsureFailedClass: ClassWithSmallLintErrors
				failedMethod: #returnInEnsure
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
returnsBooleanAndOther
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				returnsBooleanAndOtherFailedClass: ClassWithSmallLintErrors
				failedMethod: #returnsBooleanAndOther
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
returnsIfTrue
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				returnsIfTrueFailedClass: ClassWithSmallLintErrors
				failedMethod: #returnsIfTrue
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
searchingLiteral
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				searchingLiteralFailedClass: ClassWithSmallLintErrors
				failedMethod: #searchingLiteral
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
sendsDifferentSuper
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				sendsDifferentSuper: #printString
				failedClass: ClassWithSmallLintErrors
				failedMethod: #sendsDifferentSuper
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - bugs' stamp: 'HAW 12/18/2005 14:37'!
sendsUnknownMessageToGlobal
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				sendsUnknownMessageToGlobalFailedClass: ClassWithSmallLintErrors
				failedMethod: #sendsUnknownMessageToGlobal
				reasonDescription: 'For testing reason'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - bugs' stamp: 'HAW 12/18/2005 14:37'!
sentNotImplemented
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				sentNotImplemented: #xxxyyy
				failedClass: ClassWithSmallLintErrors
				failedMethod: #sentNotImplemented
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'initialization' stamp: 'HAW 12/18/2005 14:33'!
setUp
	SmallLintRuleInformation initialize! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
sizeCheck
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				sizeCheckFailedClass: ClassWithSmallLintErrors
				failedMethod: #sizeCheck
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
stringConcatenation
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				stringConcatenationFailedClass: ClassWithSmallLintErrors
				failedMethod: #stringConcatenation
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - bugs' stamp: 'HAW 12/18/2005 14:36'!
subclassResponsibilityNotDefined
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				subclassResponsibilityNotDefinedFailedClass: SuperclassOfClassesWithSmallLintErrors
				failedMethod: #subclassResponsibilityNotDefined
				reasonDescription: 'For testing reason'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
superSends
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				superSendsFailedClass: ClassWithSmallLintErrors
				failedMethod: #release
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
tempsReadBeforeWritten
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				tempsReadBeforeWritten: 'a'
				failedClass: ClassWithSmallLintErrors
				failedMethod: #tempsReadBeforeWritten
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:38'!
tempVarOverridesInstVar
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				tempVarOverridesInstVar: 'instanceVariableToOverride'
				failedClass: ClassWithSmallLintErrors2
				failedMethod: #tempVarOverridesInstVar
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
threeElementPoint
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				threeElementPointFailedClass: ClassWithSmallLintErrors
				failedMethod: #threeElementPoint
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
toDo
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				toDoFailedClass: ClassWithSmallLintErrors
				failedMethod: #toDo
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
toDoCollect
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				toDoCollectFailedClass: ClassWithSmallLintErrors
				failedMethod: #toDoCollect
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
toDoWithIncrement
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				toDoWithIncrementFailedClass: ClassWithSmallLintErrors
				failedMethod: #toDoWithIncrement
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
unnecessaryAssignment
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				unnecessaryAssignmentFailedClass: ClassWithSmallLintErrors
				failedMethod: #unnecessaryAssignment
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
unoptimizedAndOr
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				unoptimizedAndOrFailedClass: ClassWithSmallLintErrors
				failedMethod: #unoptimizedAndOr
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
unoptimizedToDo
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				unoptimizedToDoFailedClass: ClassWithSmallLintErrors
				failedMethod: #unoptimizedToDo
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
unreferencedVariables
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				unreferencedVariablesFailedClass: ClassWithSmallLintErrors
				failedVariable: 'unreferencedVariable'
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - possible bugs' stamp: 'HAW 12/18/2005 14:37'!
usesAdd
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				usesAddFailedClass: ClassWithSmallLintErrors
				failedMethod: #usesAdd
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - bugs' stamp: 'HAW 12/18/2005 14:37'!
usesTrue
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				usesTrueFailedClass: ClassWithSmallLintErrors
				failedMethod: #usesTrue
				reasonDescription: 'For testing reason'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
utilityMethods
	"The utilityMethods small lint rule is not working properly. Needs to be rework. When that rule is fixed, this test will fail. If that happens, 
	just remove the on:do: message - Hernan"

	
	[self assertExpectedFailure: (ExpectedSmallLintFailure 
				utilityMethodsFailedClass: ClassWithSmallLintErrors
				failedMethod: #utilityMethods:
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan').
	self 
		error: 'It should not get here. If it does, it means that the rule is working and the test has to be chaned'] 
			on: TestResult failure
			do: [:anException | anException return]! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
variableAssignedLiteral
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				variableAssignedLiteralFailedClass: ClassWithSmallLintErrors
				failedVariable: 'instanceVariable'
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - bugs' stamp: 'HAW 12/18/2005 14:37'!
variableNotDefined
	"This small lint rule is not implemented. I provide this test so when the rule works it will fail. If that happens, the test
	will have to be written again, because as it is now, it does not work - Hernan"

	
	[self assertExpectedFailure: (ExpectedSmallLintFailure 
				variableNotDefined: #aVariable
				failedClass: ClassWithSmallLintErrors
				failedMethod: #variableNotDefined
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan').
	self 
		error: 'It should not get here. If it does, it means that the rule is working and the test has to be chaned'] 
			on: TestResult failure
			do: [:anException | anException return]! !

!SmallLintFailureTest methodsFor: 'test - unnecesary code' stamp: 'HAW 12/18/2005 14:37'!
variableReferencedOnce
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				variableReferencedOnce: 'instanceVariable'
				failedClass: ClassWithSmallLintErrors
				failedMethod: #variableReferencedOnce
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - intention revealing' stamp: 'HAW 12/18/2005 14:37'!
whileTrue
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				whileTrueFailedClass: ClassWithSmallLintErrors
				failedMethod: #whileTrue
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

!SmallLintFailureTest methodsFor: 'test - miscellaneous' stamp: 'HAW 12/18/2005 14:37'!
yourselfNotUsed
	self assertExpectedFailure: (ExpectedSmallLintFailure 
				yourselfNotUsedFailedClass: ClassWithSmallLintErrors
				failedMethod: #yourselfNotUsed
				reasonDescription: 'For testing porpouses'
				definedBy: 'Hernan')! !

TestCase subclass: #SmallLintMethodFailureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!SmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 15:33'!
testExpectedFailureInstanceCreationCodeTemplate
	| failure lintRule failedClass expectedCodeTemplate expectedMethodTextTemplate failedSelector |
	expectedCodeTemplate := 'ExpectedSmallLintFailure usesTrueFailedClass: self failedMethod: ''test'' asSymbol reasonDescription: <aString> definedBy: ''' 
				, Utilities authorInitials , ''''.
	expectedMethodTextTemplate := 'ExpectedSmallLintFailure usesTrue: <Text> failedClass: self failedMethod: ''test'' asSymbol reasonDescription: <aString> definedBy: ''' 
				, Utilities authorInitials , ''''.
	lintRule := MockLintRule named: 'Uses True/False instead of true/false'.
	failedClass := Object.
	failedSelector := #test.
	failure := SmallLintMethodFailure 
				for: lintRule
				class: failedClass
				selector: failedSelector.
	self
		assert: failure expectedFailureInstanceCreationCodeTemplate 
					= expectedCodeTemplate;
		assert: failure expectedMethodTextFailureInstanceCreationCodeTemplate 
					= expectedMethodTextTemplate! !

!SmallLintMethodFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:35'!
testInstanceCreation
	| failure lintRule failedClass failedSelector |
	failedSelector := #test.
	lintRule := MockLintRule named: 'Class not referenced'.
	failedClass := Object.
	failure := SmallLintMethodFailure 
				for: lintRule
				class: failedClass
				selector: failedSelector.
	self
		assert: failure rule = lintRule;
		assert: failure failedClass = failedClass;
		assert: failure failedMethod = failedSelector;
		assert: failure printString notNil;
		assert: failure ruleName = lintRule name! !

TestCase subclass: #SmallLintRuleInformationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!SmallLintRuleInformationTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:33'!
calculateNumberOfRules
	| numberOfDefaultRules |
	numberOfDefaultRules := 0.
	BasicLintRule withAllSubclasses do: 
			[:aClass | 
			BasicLintRule protocols do: 
					[:aCategoryName | 
					(aClass class allMethodsInCategory: aCategoryName) do: 
							[:aSelector | 
							| rule |
							rule := aClass perform: aSelector.
							self assert: rule name = (SmallLintRuleInformation ruleNameFor: aSelector).
							self 
								assert: (SmallLintRuleInformation ruleIdentifierFor: rule) = aSelector.
							self assert: aClass = (SmallLintRuleInformation ruleClassFor: aSelector).
							numberOfDefaultRules := numberOfDefaultRules + 1]]].
	^numberOfDefaultRules! !

!SmallLintRuleInformationTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:33'!
testInitialize
	| numberOfDefaultRules |
	SmallLintRuleInformation initialize.
	numberOfDefaultRules := self calculateNumberOfRules.
	self assert: SmallLintRuleInformation numberOfRules = numberOfDefaultRules! !

!SmallLintRuleInformationTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:33'!
testInstanceCreation
	| ruleClass ruleInformation ruleIdentifier ruleName |
	ruleClass := Smalltalk at: #BlockLintRule.
	ruleIdentifier := #definesEqualNotHash.
	ruleName := 'Defines = but not hash'.
	ruleInformation := SmallLintRuleInformation 
				ruleClass: ruleClass
				ruleIdentifier: ruleIdentifier
				name: ruleName.
	self
		assert: ruleInformation ruleClass = ruleClass;
		assert: ruleInformation ruleIdentifier = ruleIdentifier;
		assert: ruleInformation ruleName = ruleName;
		assert: ruleInformation printString notNil;
		assert: ruleInformation rule name = 'Defines = but not hash'! !

!SmallLintRuleInformationTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:33'!
testNumberOfRules
	"If this test fails, it means:
	1) There are more small lint rules, so the corresponding small lint failures has to be defined
	2) There are less small lint rules, so the corresponding small lint failures has to be deleted
	Hernan"

	self assert: SmallLintRuleInformation numberOfRules = 75! !

!SmallLintRuleInformationTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:33'!
testRuleClassFor
	self 
		assert: (SmallLintRuleInformation ruleClassFor: #definesEqualNotHash) 
				= (Smalltalk at: #BlockLintRule)! !

TestCase subclass: #SmallLintVariableFailureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-Tests'!

!SmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 15:33'!
testExpectedFailureInstanceCreationCodeTemplate
	| failure lintRule failedClass expectedCodeTemplate failedVariable |
	expectedCodeTemplate := 'ExpectedSmallLintFailure unreferencedVariablesFailedClass: self failedVariable: ''test'' reasonDescription: <aString> definedBy: ''' 
				, Utilities authorInitials , ''''.
	lintRule := MockLintRule named: 'Variables not referenced'.
	failedClass := Object.
	failedVariable := 'test'.
	failure := SmallLintVariableFailure 
				for: lintRule
				class: failedClass
				variableName: failedVariable.
	self assert: failure expectedFailureInstanceCreationCodeTemplate 
				= expectedCodeTemplate! !

!SmallLintVariableFailureTest methodsFor: 'test' stamp: 'HAW 12/18/2005 14:35'!
testInstanceCreation
	| failure lintRule failedClass failedVariable |
	failedVariable := 'test'.
	lintRule := MockLintRule named: 'Class not referenced'.
	failedClass := Object.
	failure := SmallLintVariableFailure 
				for: lintRule
				class: failedClass
				variableName: failedVariable.
	self
		assert: failure rule = lintRule;
		assert: failure failedClass = failedClass;
		assert: failure failedVariable = failedVariable;
		assert: failure printString notNil;
		assert: failure ruleName = lintRule name! !

!TestCase class methodsFor: '*small lint failure-model' stamp: 'HAW 12/19/2005 10:41'!
expectedNotReferenceClass 
	^Array with: (ExpectedSmallLintFailure 
				classNotReferencedFailedClass: self
				reasonDescription: 'Las clases de test no son referenciadas nunca'
				definedBy: 'hernan')
		with: (ExpectedSmallLintFailure 
				classNotReferencedFailedClass: self class
				reasonDescription: 'Las clases de test no son referenciadas nunca'
				definedBy: 'hernan')! !

!TestCase class methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 14:31'!
expectedNotSendMessages
	^self buildSuite tests collect: 
			[:aTest | 
			ExpectedSmallLintFailure 
				implementedNotSentFailedClass: self
				failedMethod: aTest selector
				reasonDescription: 'Es un test'
				definedBy: 'Hernan']! !

!TestCase class methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 14:31'!
expectedSmallLintFailures
	^Array with: (ExpectedSmallLintFailure 
				utilityMethodsFailedClass: self
				failedMethod: #executeShould:inScopeOf:withSignalDo:
				reasonDescription: 'Este utility method es intencional'
				definedBy: 'diegof')! !

!TestCase class methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 12:41'!
inheritedExpectedSmallLintFailures

	"All the test cases but TestCase are not reference and the have messages not sent. That is why this expected small lint failures
	are inherited by all test cases"
	
	^self = TestCase
		ifTrue: [ super inheritedExpectedSmallLintFailures ]
		ifFalse: [ super inheritedExpectedSmallLintFailures, self expectedNotSendMessages, self expectedNotReferenceClass ]
! !

!BasicLintRule methodsFor: '*small lint failure-model' stamp: 'HAW 12/17/2005 11:17'!
failures

	^result failuresFor: self! !

!NotEnvironment methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 12:33'!
failuresFor: aLintRule 

	self error: 'The implementation does not support failures for this environment'! !

!RefactoringBrowser methodsFor: '*small lint failure-ui' stamp: 'HAW 12/19/2005 10:40'!
expectedSmallLintOnClass

	self selectedClass ifNotNil: [ self runExpectedSmallLintFailuresOn: (BrowserEnvironment new forClasses: {self selectedClass}) ] 
! !

!RefactoringBrowser methodsFor: '*small lint failure-ui' stamp: 'HAW 12/19/2005 10:20'!
expectedSmallLintOnClassCategory

	| env |
	
	env := self environmentForSelectedClassCategory.
	env ifNotNil: [ self runExpectedSmallLintFailuresOn: env ]
! !

!RefactoringBrowser methodsFor: '*small lint failure-ui' stamp: 'HAW 12/19/2005 10:20'!
expectedSmallLintOnClassHierarchy

	| env |
	
	env := self environmentForSelectedClassHierarchy.
	env ifNotNil: [ self runExpectedSmallLintFailuresOn: env ]
! !

!RefactoringBrowser methodsFor: '*small lint failure-ui' stamp: 'HAW 12/19/2005 10:21'!
expectedSmallLintOnPackageWithClassCategory

	| env |
	
	env := self environmentForPackageWithClassCategory.
	env ifNotNil: [ self runExpectedSmallLintFailuresOn: env ]! !

!RefactoringBrowser methodsFor: '*small lint failure-ui' stamp: 'HAW 12/19/2005 10:32'!
runExpectedSmallLintFailuresOn: anEnvironment

	Cursor wait showWhile: [ | message |
		message := ProgressMorph label: 'Running Expected Small Lint Failures'.
		message openInWorld.
		(Delay forMilliseconds: 100) wait.
		[ SmallLintFailureResultWindow runAndShowResultsOn: anEnvironment ] ensure: [ message delete ] ].

! !

!BrowserEnvironmentWrapper methodsFor: '*small lint failure-model' stamp: 'HAW 12/17/2005 11:17'!
failuresFor: aLintRule 

	self subclassResponsibility! !

!ClassEnvironment methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 14:32'!
failuresFor: aLintRule 
	| fails |
	fails := OrderedCollection new.
	self 
		classesDo: [:aClass | fails add: (SmallLintClassFailure for: aLintRule in: aClass)].
	^fails! !

Model subclass: #SmallLintFailureResultWindow
	instanceVariableNames: 'checker selectedNotExplainedFailureIndex selectedNotUsedExpectedFailureIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Small Lint Failure-UI'!

!SmallLintFailureResultWindow class methodsFor: 'instance creation' stamp: 'HAW 12/18/2005 22:09'!
on: anEnvironment

	^self new initializeOn: anEnvironment
! !

!SmallLintFailureResultWindow class methodsFor: 'instance creation' stamp: 'HAW 12/18/2005 22:09'!
runAndShowResultsOn: anEnvironment

	(self on: anEnvironment) runAndOpen
! !

!SmallLintFailureResultWindow methodsFor: 'not explained failure list' stamp: 'HAW 12/18/2005 23:53'!
copyNotExplainedFailureTemplate

	Clipboard clipboardText: (checker notExplainedFailures at: selectedNotExplainedFailureIndex) expectedFailureInstanceCreationCodeTemplate
	! !

!SmallLintFailureResultWindow methodsFor: 'initialization' stamp: 'HAW 12/18/2005 22:02'!
initializeOn: anEnvironment

	checker _ SmallLintFailureChecker environment: anEnvironment.
! !

!SmallLintFailureResultWindow methodsFor: 'initialization' stamp: 'HAW 12/18/2005 22:45'!
initializeSelectedNotExplainedFailureIndex 

	selectedNotExplainedFailureIndex _ checker notExplainedFailures notEmpty
		ifTrue: [ 1 ]
		ifFalse: [ 0 ]
! !

!SmallLintFailureResultWindow methodsFor: 'not used expected failure list' stamp: 'HAW 12/18/2005 23:03'!
initializeSelectedNotUsedExpectedFailureIndex 

	selectedNotUsedExpectedFailureIndex _ checker notUsedExpectedFailures notEmpty ifTrue: [ 1 ] ifFalse: [ 0 ].

! !

!SmallLintFailureResultWindow methodsFor: 'not explained failure list' stamp: 'HAW 12/18/2005 22:59'!
notExplainedFailures

	^checker notExplainedFailures! !

!SmallLintFailureResultWindow methodsFor: 'not explained failure list' stamp: 'HAW 12/18/2005 22:59'!
notExplainedFailuresListMorph

	| list |
	
	list := PluggableListMorph 
			on: self
			list: #notExplainedFailures
			selected: #selectedNotExplainedFailureIndex
			changeSelected: #selectedNotExplainedFailureIndex:
			menu: #notExplainedFailuresMenu:.
			
	^list! !

!SmallLintFailureResultWindow methodsFor: 'not explained failure list' stamp: 'HAW 12/18/2005 23:23'!
notExplainedFailuresMenu: aMenu

	^ aMenu
		add: 'Open browser on failure' action: #openBrowserOnNotExplainedFailure;
		add: 'Copy expected failure template' action: #copyNotExplainedFailureTemplate ! !

!SmallLintFailureResultWindow methodsFor: 'not used expected failure list' stamp: 'HAW 12/18/2005 22:59'!
notUsedExpectedFailures

	^checker notUsedExpectedFailures ! !

!SmallLintFailureResultWindow methodsFor: 'not used expected failure list' stamp: 'HAW 12/18/2005 23:00'!
notUsedExpectedFailuresListMorph

	| list |
	
	list := PluggableListMorph 
			on: self
			list: #notUsedExpectedFailures
			selected: #selectedNotUsedExpectedFailureIndex
			changeSelected: #selectedNotUsedExpectedFailureIndex:
			menu: #notUsedExpectedFailuresMenu:.
			
	^list! !

!SmallLintFailureResultWindow methodsFor: 'not used expected failure list' stamp: 'HAW 12/18/2005 23:57'!
notUsedExpectedFailuresMenu: aMenu

	^aMenu add: 'Open browser on failure definition' action: #openBrowserOnNotUsedExpectedFailure
! !

!SmallLintFailureResultWindow methodsFor: 'opening' stamp: 'HAW 12/18/2005 22:17'!
open

	^(SystemWindow labelled: 'Small Lint Failures Result (Not Explained/Not Used)')
		model: self;
		addMorph: (self notExplainedFailuresListMorph) frame:(0@0 extent: 1@0.5);
		addMorph: (self notUsedExpectedFailuresListMorph) frame: (0@0.5 extent: 1@0.5);
		openInWorld;
		yourself! !

!SmallLintFailureResultWindow methodsFor: 'not explained failure list' stamp: 'HAW 12/18/2005 23:46'!
openBrowserOnNotExplainedFailure

	(checker notExplainedFailures at: selectedNotExplainedFailureIndex) definedEnvironment openEditor
	! !

!SmallLintFailureResultWindow methodsFor: 'not used expected failure list' stamp: 'HAW 12/19/2005 00:10'!
openBrowserOnNotUsedExpectedFailure

	| env failedClass |
	
	failedClass := (checker notUsedExpectedFailures at: selectedNotUsedExpectedFailureIndex) failedClass.
	env := SelectorEnvironment 
		onMethods: (Array with: #expectedSmallLintFailures) 
		forClass: (failedClass isMeta ifTrue: [ failedClass ] ifFalse: [ failedClass class ])
		in: BrowserEnvironment new.
	(SelectorEnvironmentBrowser openOnEnvironment: env) openInWorld
! !

!SmallLintFailureResultWindow methodsFor: 'opening' stamp: 'HAW 12/18/2005 23:26'!
perform: selector orSendTo: otherTarget

	^self perform: selector! !

!SmallLintFailureResultWindow methodsFor: 'opening' stamp: 'HAW 12/19/2005 10:22'!
runAndOpen

	self runChecker.
	self open.
! !

!SmallLintFailureResultWindow methodsFor: 'opening' stamp: 'HAW 12/18/2005 22:02'!
runChecker

	checker value.
! !

!SmallLintFailureResultWindow methodsFor: 'not explained failure list' stamp: 'HAW 12/18/2005 22:42'!
selectedNotExplainedFailureIndex

	selectedNotExplainedFailureIndex ifNil: [ self initializeSelectedNotExplainedFailureIndex ].
	^selectedNotExplainedFailureIndex! !

!SmallLintFailureResultWindow methodsFor: 'not explained failure list' stamp: 'HAW 12/18/2005 22:55'!
selectedNotExplainedFailureIndex: aNumber

	selectedNotExplainedFailureIndex _ aNumber.
	self changed: #selectedNotExplainedFailureIndex
! !

!SmallLintFailureResultWindow methodsFor: 'not used expected failure list' stamp: 'HAW 12/18/2005 23:01'!
selectedNotUsedExpectedFailureIndex

	selectedNotUsedExpectedFailureIndex ifNil: [ self initializeSelectedNotUsedExpectedFailureIndex ].
	^selectedNotUsedExpectedFailureIndex

! !

!SmallLintFailureResultWindow methodsFor: 'not used expected failure list' stamp: 'HAW 12/18/2005 23:04'!
selectedNotUsedExpectedFailureIndex: aNumber

	selectedNotUsedExpectedFailureIndex _ aNumber.
	self changed: #selectedNotUsedExpectedFailureIndex
! !

!VariableEnvironment class methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 14:48'!
smallLintFailureOn: anEnvironment referencesToInstanceVariable: aString in: aClass 
	
	"I added this method becouase on:referencesToInstanceVariable:in: does not work the same way as the version in visual age - Hernan"
	
	^(self onEnvironment: anEnvironment)
		label: 'References to ''' , aString , ''' in ' , aClass name;
		addClass: aClass instanceVariable: aString;
		yourself! !

!VariableEnvironment class methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 14:47'!
smallLintFailureReferencesToInstanceVariable: aString in: aClass 

	"I had to do this method because the version of on:referencesToInstanceVariable:in: does not work as in visual age... - Hernan"
	
	^self 
		smallLintFailureOn: BrowserEnvironment new
		referencesToInstanceVariable: aString
		in: aClass! !

!VariableEnvironment methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 14:33'!
failuresFor: aLintRule 
	| fails |
	fails := OrderedCollection new.
	self classesDo: 
			[:aClass | 
			(self instanceVariablesFor: aClass) do: 
					[:aVariableName | 
					fails add: (SmallLintVariableFailure 
								for: aLintRule
								class: aClass
								variableName: aVariableName)].
			(self classVariablesFor: aClass) do: 
					[:aVariableName | 
					fails add: (SmallLintVariableFailure 
								for: aLintRule
								class: aClass
								variableName: aVariableName)]].
	^fails! !

!MultiEnvironment methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 14:33'!
failuresFor: aLintRule 
	^self environments collect: 
			[:aString | 
			| parsedString class selector |
			parsedString := aString subStrings: '>'.
			class := Smalltalk classNamed: parsedString first.
			selector := parsedString last asSymbol.
			SmallLintMethodFailure 
				for: aLintRule
				class: class
				selector: selector]! !

!SelectorEnvironment class methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 12:39'!
implementorsMatchingAll: aStringCollection in: anEnvironment 

	"This method has been imported from the VisualAge small lint - Hernan"
	
	| classDict metaDict |
	classDict := IdentityDictionary new.
	metaDict := IdentityDictionary new.
	aStringCollection do: [ :eachString |
		self implementorsMatching: eachString
			in: anEnvironment
			storeClassSelectorsIn: classDict
			andStoreMetaClassSelectorsIn: metaDict].
	
	^(self onEnvironment: anEnvironment)
		classSelectors: classDict metaClassSelectors: metaDict;
		label: 'Implementors of ' , aStringCollection printString;
		yourself! !

!SelectorEnvironment class methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 12:39'!
implementorsMatching: aString in: anEnvironment storeClassSelectorsIn: aClassesDictionary andStoreMetaClassSelectorsIn: aMetaClassesDictionary

	"This method has been imported from the VisualAge small lint - Hernan"

	anEnvironment classesDo: [:class | | selectors |
		selectors := Set new.
		anEnvironment
			selectorsForClass: class
			do: [:each | (aString match: each) ifTrue: [selectors add: each]].
		selectors notEmpty
			ifTrue: [
				class isMetaclass
					ifTrue: [ self put: selectors in: aMetaClassesDictionary at: class primaryInstance name ]
					ifFalse: [ self put: selectors in: aClassesDictionary at: class name ]]]! !

!SelectorEnvironment class methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 12:39'!
put: aSelectorsCollection in: aMetaClassesOrClassesDictionary at: aKeyName

	"This method has been imported from the VisualAge small lint - Hernan"

	aMetaClassesOrClassesDictionary at: aKeyName ifAbsentPut: [ Set new ].
	(aMetaClassesOrClassesDictionary at: aKeyName) addAll: aSelectorsCollection! !

!SelectorEnvironment methodsFor: '*small lint failure-model' stamp: 'HAW 12/18/2005 14:33'!
failuresFor: aLintRule 
	| fails |
	fails := OrderedCollection new.
	self classesAndSelectorsDo: 
			[:aClass :aSelector | 
			fails add: (SmallLintMethodFailure 
						for: aLintRule
						class: aClass
						selector: aSelector)].
	^fails! !
SmallLintRuleInformation initialize!
